      INTEGER FUNCTION  NLSCKD (DUMMY)
C     (NAMELIST - Check Delimiter)
C     Flush any trailing blanks and  position the input past  the
C     delimiting comma,  or  at  a dollar.   The  function  value
C     returned is OKAY, SYNERR, or EOFERR.  No error messages are
C     issued; that job is left to the caller.
C     (14-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFS       NLSGNB,      NLSNC
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             NLSGNB,      NLSNC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             ISDOLL
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CODE
C
      INTEGER             ARG,         CODE,        DUMMY
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS02  /
C
      INTEGER             UCORD
      COMMON / NLS02  /   UCORD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS07  /
C
C     UNUSED              BLANK,       DQUOTE,      EQUALS,      HASHMK
C     UNUSED              LPAREN,      MINUS,       PERIOD,      PLUS
C     UNUSED              RPAREN,      SQUOTE,      STAR,        UCD
C     UNUSED              UCE,         UCF,         UCQ,         UCT
C     UNUSED              USCORE
C
      INTEGER             AMPSND,      BLANK,       COMMA,       DOLLAR
      INTEGER             DQUOTE,      EQUALS,      HASHMK,      LPAREN
      INTEGER             MINUS,       PERIOD,      PLUS,        RPAREN
      INTEGER             SQUOTE,      STAR,        UCD,         UCE
      INTEGER             UCF,         UCQ,         UCT,         USCORE
      COMMON / NLS07  /   AMPSND,      BLANK,       COMMA,       DOLLAR
      COMMON / NLS07  /   DQUOTE,      EQUALS,      HASHMK,      LPAREN
      COMMON / NLS07  /   MINUS,       PERIOD,      PLUS,        RPAREN
      COMMON / NLS07  /   SQUOTE,      STAR,        UCD,         UCE
      COMMON / NLS07  /   UCF,         UCQ,         UCT,         USCORE
C
      ISDOLL(ARG) = (ARG .EQ. DOLLAR) .OR. (ARG .EQ. AMPSND)
C
      CODE = NLSGNB (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 30
      IF (ISDOLL(UCORD)) GO TO 10
      IF (UCORD .NE. COMMA) GO TO 20
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 30
C
C     Termination section.
C
   10 NLSCKD = OKAY
      GO TO 40
C
   20 NLSCKD = SYNERR
      GO TO 40
C
   30 NLSCKD = EOFERR
      GO TO 40
C
   40 RETURN
      END
      INTEGER FUNCTION  NLSDFC (VALUE,MODE,TOKEN,NEXT)
C     (NAMELIST - Decode Floating-point Constant)
C     Decode a floating-point (or  integer) constant in  TOKEN(*)
C     beginning at position  NEXT.  Leading  and trailing  blanks
C     are ignored, but embedded  blanks are illegal.  On  return,
C     the value of  the constant is  in VALUE, its  type in  MODE
C     (TYPINT or TYPDBL), and NEXT is advanced to the  delimiting
C     comma or right parenthesis following the constant (but  not
C     beyond the EOS marker in TOKEN(*)).  The function value  is
C     OKAY or SYNERR.  Issuing of  error messages is left to  the
C     caller.
C
C     The usual FORTRAN  integer and  floating-point formats  are
C     acceptable (E,  D,  and  Q exponents).   In  addition,  two
C     extensions from the Ada language are permitted:
C
C          Underscores may  be  present BETWEEN  digits  for
C          readability,  and  are  ignored.   Examples   are
C          1_100_347, 3.141_592_65, and 10000_00000.0.
C
C          Number bases in the range 2..16 may be  specified
C          for INTEGER constant values only by prefixing the
C          integer with the base and a # sign, for  example,
C          2#101,   8#77377,   10#2500,   16#3AF4E.    Based
C          integers are  illegal in  exponent fields.   This
C          does NOT permit entry  of arbitrary bit  patterns
C          into  variables,  since  the  accumulated  value,
C          taken as a positive number, must be assignable to
C          an integer variable without overflow.
C     (18-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       DBLE,        FLOAT,       INT,         MAX0
C     EXTERNAL REFS       NLSGDV,      SNGL
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             NLSGDV
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      DOUBLE PRECISION    DBLE
      INTEGER             INT,         MAX0
      REAL                FLOAT,       SNGL
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             EXPLET,      ISUSC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                BASE,        BASED,       DIGIT,       EOS
C     SETS                MODE,        NAFTER,      NBASE,       NBEFOR
C     SETS                NEXP,        NEXT,        NSIGN,       PBIAS
C     SETS                POWER,       PSIGN,       VALUE,       WASUSC
C
      DOUBLE PRECISION    BASE,        VALUE
      INTEGER             ARG,         DIGIT,       EOS,         MODE
      INTEGER             NAFTER,      NBASE,       NBEFOR,      NEXP
      INTEGER             NEXT,        NSIGN,       PBIAS,       POWER
      INTEGER             PSIGN,       TOKEN(1)
      LOGICAL             BASED,       WASUSC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
C     UNUSED              EOFERR
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS06  /
C
C     UNUSED              TYPCPX,      TYPEND,      TYPHOL,      TYPLOG
C     UNUSED              TYPNUL,      TYPSGL,      TYPVAR
C
      INTEGER             TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
      INTEGER             TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
      INTEGER             TYPVAR
      COMMON / NLS06  /   TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
      COMMON / NLS06  /   TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
      COMMON / NLS06  /   TYPVAR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS07  /
C
C     UNUSED              AMPSND,      DOLLAR,      DQUOTE,      EQUALS
C     UNUSED              LPAREN,      SQUOTE,      STAR,        UCF
C     UNUSED              UCT
C
      INTEGER             AMPSND,      BLANK,       COMMA,       DOLLAR
      INTEGER             DQUOTE,      EQUALS,      HASHMK,      LPAREN
      INTEGER             MINUS,       PERIOD,      PLUS,        RPAREN
      INTEGER             SQUOTE,      STAR,        UCD,         UCE
      INTEGER             UCF,         UCQ,         UCT,         USCORE
      COMMON / NLS07  /   AMPSND,      BLANK,       COMMA,       DOLLAR
      COMMON / NLS07  /   DQUOTE,      EQUALS,      HASHMK,      LPAREN
      COMMON / NLS07  /   MINUS,       PERIOD,      PLUS,        RPAREN
      COMMON / NLS07  /   SQUOTE,      STAR,        UCD,         UCE
      COMMON / NLS07  /   UCF,         UCQ,         UCT,         USCORE
C
      DATA             EOS /-1/
C
      EXPLET(ARG) = (ARG .EQ. UCD) .OR. (ARG .EQ. UCE) .OR.(ARG .EQ.UCQ)
      ISUSC(ARG) = (ARG .EQ. USCORE)
C
C     Establish the default number base.
C
      NBASE = 10
      BASE = 10.0D+00
      BASED = .FALSE.
      WASUSC = .TRUE.
C
C     Flush leading blanks.
C
   10 IF (TOKEN(NEXT) .NE. BLANK) GO TO 20
      NEXT = NEXT + 1
      GO TO 10
C
C     Flag values:
C     NSIGN =   0    no sign present
C              -1    minus sign
C              +1    plus sign
C     NBEFOR =       number of digits before decimal point
C     NAFTER = -1    no decimal point or fraction
C            =  0    decimal point, no fraction
C            >  0    decimal point, NAFTER fractional digits
C     NEXP =   -1    no floating-point exponent
C          =    0    exponent letter found
C          >    0    exponent with NEXP digits
C     PBIAS =        number of fractional digits found
C     PSIGN =   0    no exponent sign
C              -1    negative exponent
C              +1    positive exponent
C
   20 NSIGN = 0
      NBEFOR = 0
      NAFTER = -1
      NEXP = -1
      PBIAS = 0
      POWER = 0
      PSIGN = 0
      VALUE = 0.0D+00
C
C     Decode any leading sign.
C
      IF (TOKEN(NEXT) .NE. PLUS) GO TO 30
      NSIGN = +1
      NEXT = NEXT + 1
      GO TO 40
   30 IF (TOKEN(NEXT) .NE. MINUS) GO TO 40
      NEXT = NEXT + 1
      NSIGN = -1
C
C     Decode the  integer  part  of  the  value,  accumulating  a
C     negative sum (since two's complement has one more  negative
C     number than positive numbers).
C
   40 IF (ISUSC(TOKEN(NEXT)) .AND. (.NOT.WASUSC)) GO TO 50
      DIGIT = NLSGDV (TOKEN(NEXT),NBASE)
      IF (DIGIT .LT. 0) GO TO 60
      NBEFOR = NBEFOR + 1
      VALUE = VALUE*BASE - DBLE(FLOAT(DIGIT))
   50 WASUSC = ISUSC(TOKEN(NEXT))
      NEXT = NEXT + 1
      GO TO 40
   60 IF (ISUSC(TOKEN(NEXT))) GO TO 170
C
C     Check for an  explicit number  base (nn#intval).   Repeated
C     bases, or bases out  of the range  2..16, are illegal.   If
C     one is  found, the  scan is  restarted.  This  is the  only
C     place where we have to jump backwards in the code.
C
      IF (BASED .OR. (TOKEN(NEXT) .NE. HASHMK)) GO TO 70
      NBASE = INT(SNGL(-VALUE))
      IF ((NBASE .LT. 2) .OR. (16 .LT. NBASE)) GO TO 170
      BASE = -VALUE
      BASED = .TRUE.
      NEXT = NEXT + 1
      GO TO 20
C
C     Check for a fractional part.
C
   70 IF (TOKEN(NEXT) .NE. PERIOD) GO TO 100
      NEXT = NEXT + 1
      NAFTER = 0
      WASUSC = .TRUE.
C
C     Found the  decimal  point.   Decode  the  fractional  part,
C     adjusting  the  final  exponent  downward  for  each  digit
C     accumulated.
C
   80 IF (ISUSC(TOKEN(NEXT)) .AND. (.NOT.WASUSC)) GO TO 90
      DIGIT = NLSGDV (TOKEN(NEXT),NBASE)
      IF (DIGIT .LT. 0) GO TO 100
      NAFTER = NAFTER + 1
      PBIAS = PBIAS - 1
      VALUE = VALUE*BASE - DBLE(FLOAT(DIGIT))
   90 WASUSC = ISUSC(TOKEN(NEXT))
      NEXT = NEXT + 1
      GO TO 80
  100 IF (ISUSC(TOKEN(NEXT))) GO TO 170
C
C     Check for an exponent letter.  E, D, and Q are acceptable.
C
      IF (.NOT.EXPLET(TOKEN(NEXT))) GO TO 140
      NEXT = NEXT + 1
      NEXP = 0
      WASUSC = .TRUE.
C
C     Check for an exponent sign.
C
      IF (TOKEN(NEXT) .NE. PLUS) GO TO 110
      PSIGN = +1
      NEXT = NEXT + 1
  110 IF (TOKEN(NEXT) .NE. MINUS) GO TO 120
      PSIGN = -1
      NEXT = NEXT + 1
C
C     We must now have an unsigned decimal integer exponent.
C
  120 IF (ISUSC(TOKEN(NEXT)) .AND. (.NOT.WASUSC)) GO TO 130
      DIGIT = NLSGDV (TOKEN(NEXT),NBASE)
      IF (DIGIT .LT. 0) GO TO 140
      NEXP = NEXP + 1
      POWER = POWER*10 + DIGIT
  130 WASUSC = ISUSC(TOKEN(NEXT))
      NEXT = NEXT + 1
      GO TO 120
  140 IF (ISUSC(TOKEN(NEXT))) GO TO 170
C
C     The  various  parts  of  the  constant  have  been  decoded
C     successfully.  Do a syntax check, then include any exponent
C     factor.
C
      IF ((NBEFOR + MAX0(0,NAFTER)) .LE. 0) GO TO 170
      IF (NEXP .EQ. 0) GO TO 170
      IF (BASED .AND. ((NAFTER .GE. 0) .OR. (NBEFOR .LE. 0) .OR.
     X     (NEXP.GE. 0))) GO TO 170
      IF (NSIGN .GE. 0) VALUE = -VALUE
      IF (PSIGN .LT. 0) POWER = -POWER
      POWER = POWER + PBIAS
      IF ((VALUE .NE. 0.0D+00) .AND. (POWER .NE. 0)) VALUE = VALUE *
     X     (10.0D+00 ** POWER)
C
C     Flush any trailing blanks.
C
  150 IF (TOKEN(NEXT) .NE. BLANK) GO TO 160
      NEXT = NEXT + 1
      GO TO 150
C
C     The constant has been successfully constructed.  Now verify
C     that it  is  followed  by  a  comma  or  right  parenthesis
C     delimiter, or EOS.
C
  160 IF (.NOT.((TOKEN(NEXT) .EQ. EOS) .OR. (TOKEN(NEXT) .EQ. COMMA)
     X     .OR. (TOKEN(NEXT) .EQ. RPAREN))) GO TO 170
C
C     Everything ok.  Set the function value according to the
C     type of the constant just parsed.
C
      MODE = TYPDBL
      IF ((NAFTER .LT. 0) .AND. (NEXP .LT. 0)) MODE = TYPINT
      NLSDFC = OKAY
      GO TO 180
C
  170 NLSDFC = SYNERR
      GO TO 180
C
  180 RETURN
      END
      LOGICAL FUNCTION  NLSEQU (TEXTA,TEXTB)
C     (NAMELIST - Equal)
C     Return .TRUE.  if the  strings  TEXTA(*) and  TEXTB(*)  are
C     equal,  and  .FALSE.  if  not.   Both  are  assumed  to  be
C     terminated by an EOS marker.
C     (17-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                EOS,         I
C
      INTEGER             EOS,         I,           TEXTA(1)
      INTEGER             TEXTB(1)
C
      DATA             EOS /-1/
C
      I = 1
C
   10 NLSEQU = (TEXTA(I) .EQ. TEXTB(I))
      IF ((.NOT.NLSEQU) .OR. (TEXTA(I) .EQ. EOS)) RETURN
      I = I + 1
      GO TO 10
C
      END
      INTEGER FUNCTION  NLSFLI (DUMMY)
C     (NAMELIST - Flush Input)
C     Beginning with  the  current  character,  flush  the  input
C     stream  until  the  next  comma,  or  alphabetic  character
C     preceded by a blank or comma.   If a comma was found,  then
C     position to the  first alphabetic  character following  the
C     comma.  Flushing may be terminated prematurely by a  dollar
C     sign or end-of-file.  The  function value returned is  OKAY
C     or EOFERR.
C     (16-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       NLSGNB,      NLSNC
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             NLSGNB,      NLSNC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             ISALFA,      ISDOLL
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CODE
C
      INTEGER             ARG,         CODE,        DUMMY
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS02  /
C
      INTEGER             UCORD
      COMMON / NLS02  /   UCORD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
C     UNUSED              SYNERR
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS07  /
C
C     UNUSED              BLANK,       DQUOTE,      EQUALS,      HASHMK
C     UNUSED              LPAREN,      MINUS,       PERIOD,      PLUS
C     UNUSED              RPAREN,      SQUOTE,      STAR,        UCD
C     UNUSED              UCE,         UCF,         UCQ,         UCT
C     UNUSED              USCORE
C
      INTEGER             AMPSND,      BLANK,       COMMA,       DOLLAR
      INTEGER             DQUOTE,      EQUALS,      HASHMK,      LPAREN
      INTEGER             MINUS,       PERIOD,      PLUS,        RPAREN
      INTEGER             SQUOTE,      STAR,        UCD,         UCE
      INTEGER             UCF,         UCQ,         UCT,         USCORE
      COMMON / NLS07  /   AMPSND,      BLANK,       COMMA,       DOLLAR
      COMMON / NLS07  /   DQUOTE,      EQUALS,      HASHMK,      LPAREN
      COMMON / NLS07  /   MINUS,       PERIOD,      PLUS,        RPAREN
      COMMON / NLS07  /   SQUOTE,      STAR,        UCD,         UCE
      COMMON / NLS07  /   UCF,         UCQ,         UCT,         USCORE
C
      ISALFA(ARG) = (65 .LE. ARG) .AND. (ARG .LE. 90)
      ISDOLL(ARG) = (ARG .EQ. DOLLAR) .OR. (ARG .EQ. AMPSND)
C
C     Flush until a  comma or dollar  or alphabetic character  is
C     encountered.
C
   10 IF (UCORD .EQ. COMMA) GO TO 20
      IF (ISDOLL(UCORD)) GO TO 30
      IF (ISALFA(UCORD)) GO TO 30
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 40
      CODE = NLSGNB (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 40
      GO TO 10
C
C     A comma was  found.  Now  flush until  the next  alphabetic
C     character following.
C
   20 CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 40
      CODE = NLSGNB (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 40
      IF (ISDOLL(UCORD)) GO TO 30
      IF (ISALFA(UCORD)) GO TO 30
      GO TO 20
C
C     Termination section.
C
   30 NLSFLI = OKAY
      GO TO 50
C
   40 NLSFLI = EOFERR
C
   50 RETURN
      END
      INTEGER FUNCTION  NLSGDV (UCORD,NBASE)
C     (NAMELIST - Get Digit Value)
C     Return  as  a  function  value  the  value  of  the   digit
C     (0..NBASE-1) in  UCORD, or  -1 if  the character  is not  a
C     digit.  Number bases 2..16 are supported.
C     (18-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             NBASE,       UCORD
C
      NLSGDV = -1
      IF ((48 .LE. UCORD) .AND. (UCORD .LE. (47+NBASE))) NLSGDV = UCORD-
     X     48
      IF ((NBASE .GT. 10) .AND. (65 .LE. UCORD) .AND. (UCORD .LE.(54+
     X     NBASE))) NLSGDV = UCORD - 55
C
      RETURN
      END
      INTEGER FUNCTION  NLSGNB (DUMMY)
C     (NAMELIST - Get Next Non-blank Character)
C     Beginning with  the  current  character,  flush  the  input
C     stream up to  the next non-blank  character, leaving it  in
C     COMMON.  If the current character on entry is not a  blank,
C     no advance is made.  The function value returned is OKAY or
C     EOFERR.
C     (16-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       NLSNC
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             NLSNC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CODE
C
      INTEGER             CODE,        DUMMY
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS02  /
C
      INTEGER             UCORD
      COMMON / NLS02  /   UCORD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
C     UNUSED              SYNERR
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS07  /
C
C     UNUSED              AMPSND,      COMMA,       DOLLAR,      DQUOTE
C     UNUSED              EQUALS,      HASHMK,      LPAREN,      MINUS
C     UNUSED              PERIOD,      PLUS,        RPAREN,      SQUOTE
C     UNUSED              STAR,        UCD,         UCE,         UCF
C     UNUSED              UCQ,         UCT,         USCORE
C
      INTEGER             AMPSND,      BLANK,       COMMA,       DOLLAR
      INTEGER             DQUOTE,      EQUALS,      HASHMK,      LPAREN
      INTEGER             MINUS,       PERIOD,      PLUS,        RPAREN
      INTEGER             SQUOTE,      STAR,        UCD,         UCE
      INTEGER             UCF,         UCQ,         UCT,         USCORE
      COMMON / NLS07  /   AMPSND,      BLANK,       COMMA,       DOLLAR
      COMMON / NLS07  /   DQUOTE,      EQUALS,      HASHMK,      LPAREN
      COMMON / NLS07  /   MINUS,       PERIOD,      PLUS,        RPAREN
      COMMON / NLS07  /   SQUOTE,      STAR,        UCD,         UCE
      COMMON / NLS07  /   UCF,         UCQ,         UCT,         USCORE
C
   10 IF (UCORD .NE. BLANK) GO TO 20
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 30
      GO TO 10
C
   20 NLSGNB = OKAY
      GO TO 40
C
   30 NLSGNB = EOFERR
      GO TO 40
C
   40 RETURN
      END
      INTEGER FUNCTION  NLSGTS (VINDEX,NDIM,DIMLST)
C     (NAMELIST - Get Subscript)
C     This routine scans  off unsigned  integer subscripts  only.
C     On  entry,  the  current  character  is  the  opening  left
C     parenthesis of  the  subscript  list  (sub1,sub2,...,subN),
C     where each of the subscripts are positive unsigned  integer
C     constants, and leading and trailing blanks are ignored.  On
C     exit, the  current character  will  always be  the  closing
C     right parenthesis  (unless  end-of-file was  reached),  and
C     VINDEX will be  set to  the computed index  into the  array
C     treated as  a vector,  or  0 if  an error  occurred.   Each
C     subscript is checked  against the corresponding  dimension,
C     or if  only  one  subscript is  given,  against  the  array
C     dimension, and a syntax error  is flagged if the  dimension
C     range is exceeded.
C
C     NDIM is the  number of dimensions,  and DIMLST(*)  contains
C     the actual dimensions.  Either 1 or exactly NDIM subscripts
C     are permitted.  If only 1 is  specified, it is taken to  be
C     in the first subscript  position, and remaining  subscripts
C     are set to 1.  There is no inherent limit on the number  of
C     subscripts permitted, although Portable FORTRAN allows only
C     three.
C
C     The function  value  returned  is  OKAY  (success),  EOFERR
C     (end-of-file), or SYNERR (syntax error).
C     (16-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       NLSGUI,      NLSNC,       NLSWEM
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             NLSGUI,      NLSNC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             RNGERR
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     RUNTIME DIMENSION VARIABLES
C
      INTEGER             NDIM
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CODE,        K,           MAXSIZ,      MULT
C     SETS                VINDEX
C
      INTEGER             ARG1,        ARG2,        ARG3,        CODE
      INTEGER             DIMLST(NDIM),DUMMY,       K,           MAXSIZ
      INTEGER             MULT,        VALUE,       VINDEX
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS02  /
C
      INTEGER             UCORD
      COMMON / NLS02  /   UCORD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS07  /
C
C     UNUSED              AMPSND,      BLANK,       DOLLAR,      DQUOTE
C     UNUSED              EQUALS,      HASHMK,      MINUS,       PERIOD
C     UNUSED              PLUS,        SQUOTE,      STAR,        UCD
C     UNUSED              UCE,         UCF,         UCQ,         UCT
C     UNUSED              USCORE
C
      INTEGER             AMPSND,      BLANK,       COMMA,       DOLLAR
      INTEGER             DQUOTE,      EQUALS,      HASHMK,      LPAREN
      INTEGER             MINUS,       PERIOD,      PLUS,        RPAREN
      INTEGER             SQUOTE,      STAR,        UCD,         UCE
      INTEGER             UCF,         UCQ,         UCT,         USCORE
      COMMON / NLS07  /   AMPSND,      BLANK,       COMMA,       DOLLAR
      COMMON / NLS07  /   DQUOTE,      EQUALS,      HASHMK,      LPAREN
      COMMON / NLS07  /   MINUS,       PERIOD,      PLUS,        RPAREN
      COMMON / NLS07  /   SQUOTE,      STAR,        UCD,         UCE
      COMMON / NLS07  /   UCF,         UCQ,         UCT,         USCORE
C
      RNGERR(ARG1,ARG2,ARG3) = (ARG2 .LT. ARG1) .OR. (ARG3 .LT. ARG2)
C
C     Check that we start with an open parenthesis.
C
      IF (UCORD .NE. LPAREN) GO TO 90
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 120
C
C     Compute the array size.
C
      MAXSIZ = 1
           DO 10 K = 1,NDIM
           IF (DIMLST(K) .LE. 0) GO TO 40
   10      MAXSIZ = MAXSIZ*DIMLST(K)
C
C     Decode the first subscript and range check it.
C
      CODE = NLSGUI (VALUE)
      IF (CODE .EQ. SYNERR) GO TO 90
      IF (CODE .EQ. EOFERR) GO TO 120
      VINDEX = VALUE
      IF (RNGERR(1,VALUE,DIMLST(1)) .AND. (UCORD .NE. RPAREN)) GO TO 80
      IF (RNGERR(1,VALUE,MAXSIZ) .AND. (UCORD .EQ. RPAREN)) GO TO 80
      IF (UCORD .EQ. RPAREN) GO TO 30
      IF (NDIM .LE. 1) GO TO 70
      MULT = 1
C
C     Decode the remaining subscripts.  Each must be preceded  by
C     a comma,  and  the  last  must be  terminated  by  a  right
C     parenthesis.
C
           DO 20 K = 2,NDIM
           IF (UCORD .NE. COMMA) GO TO 60
           MULT = MULT*DIMLST(K-1)
           CODE = NLSNC (DUMMY)
           IF (CODE .EQ. EOFERR) GO TO 120
           CODE = NLSGUI (VALUE)
           IF (CODE .EQ. SYNERR) GO TO 90
           IF (CODE .EQ. EOFERR) GO TO 120
           IF (RNGERR(1,VALUE,DIMLST(K))) GO TO 80
           VINDEX = VINDEX + (VALUE - 1)*MULT
           IF ((UCORD .EQ. RPAREN) .AND. (K .LT. NDIM)) GO TO 50
           IF ((UCORD .NE. RPAREN) .AND. (K .EQ. NDIM)) GO TO 70
   20      CONTINUE
   30 NLSGTS = OKAY
      GO TO 130
C
   40 CALL NLSWEM (40HIllegal non-positive subscript dimension,40)
      GO TO 100
   50 CALL NLSWEM (30HToo few array subscripts given,30)
      GO TO 100
   60 CALL NLSWEM (43HIllegal subscript delimiter -- expected ",",43)
      GO TO 100
   70 CALL NLSWEM (41HToo many array subscripts -- expected ")",41)
      GO TO 100
   80 CALL NLSWEM (46HSubscript out of range 1..(declared dimension),46)
      GO TO 100
   90 CALL NLSWEM (44HExpected unsigned positive integer subscript,44)
  100 NLSGTS = SYNERR
      VINDEX = 0
C
C     In the event of  a syntax error, flush  up to the  expected
C     closing right parenthesis.
C
  110 IF (UCORD .EQ. RPAREN) GO TO 130
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 120
      GO TO 110
C
  120 NLSGTS = EOFERR
      VINDEX = 0
      GO TO 130
C
  130 RETURN
      END
      INTEGER FUNCTION  NLSGUI (VALUE)
C     (NAMELIST - Get Unsigned Integer)
C     With the  current character  at the  beginning of  a  field
C     containing an  unsigned  integer, compute  and  return  its
C     value in  VALUE, advancing  the  current character  to  the
C     first non-blank following  the field.   The function  value
C     returned is  OKAY  (success),  SYNERR  (syntax  error),  or
C     EOFERR (end-of-file on input).
C     (16-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       NLSGDV,      NLSGNB,      NLSNC
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             NLSGDV,      NLSGNB,      NLSNC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CODE,        DIGIT,       NDIGIT,      VALUE
C
      INTEGER             CODE,        DIGIT,       DUMMY,       NDIGIT
      INTEGER             VALUE
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS02  /
C
      INTEGER             UCORD
      COMMON / NLS02  /   UCORD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
      VALUE = 0
      NDIGIT = 0
C
C     Flush leading blanks.
C
      CODE = NLSGNB (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 40
C
C     We must now be at the start of a digit string.   Accumulate
C     the negative of the string (since two's complement has  one
C     more negative than positive number).
C
   10 DIGIT = NLSGDV (UCORD,10)
      IF (DIGIT .LT. 0) GO TO 20
      NDIGIT = NDIGIT + 1
      VALUE = VALUE*10 - DIGIT
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 40
      GO TO 10
C
C     We reached  a  non-digit  character.   Flush  any  trailing
C     blanks.  If no digits were collected, it is a syntax  error
C     condition.  Otherwise, we can return the accumulated value.
C
   20 CODE = NLSGNB (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 40
      IF (NDIGIT .LE. 0) GO TO 30
      VALUE = -VALUE
      NLSGUI = OKAY
      GO TO 50
C
   30 NLSGUI = SYNERR
      VALUE = 0
      GO TO 50
C
   40 NLSGUI = EOFERR
      VALUE = 0
      GO TO 50
C
   50 RETURN
      END
      INTEGER FUNCTION  NLSNC (DUMMY)
C     (NAMELIST - Next Character)
C     Get the next character from the input stream, reading in  a
C     new record if necessary.  Column 1 is ALWAYS ignored.   The
C     function  value  returned  is  OKAY  (success),  or  EOFERR
C     (end-of-file).   TAB  and  other  control  characters   are
C     represented by  BLANK  in  UCORD  for  convenience  in  the
C     scanning code, but the original character is maintained  in
C     HOSTCH to allow its input in character strings.
C     (18-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       KARASC,      NLSRR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             KARASC,      NLSRR
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             DUMMY
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS02  /
C
C     SETS                UCORD
C
      INTEGER             UCORD
      COMMON / NLS02  /   UCORD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS03  /
C
C     SETS                HOSTCH
C
      INTEGER             HOSTCH
      COMMON / NLS03  /   HOSTCH
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
C     UNUSED              SYNERR
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS08  /
C
C     UNUSED              LINENO
C
C     SETS                CPOS
C
      INTEGER             LINENO,      CPOS,        C
      COMMON / NLS08  /   LINENO,      CPOS,        C(80)
C
      CPOS = CPOS+1
      NLSNC = OKAY
      IF (CPOS .LT. 81) GO TO 10
      IF (NLSRR(DUMMY) .EQ. EOFERR) GO TO 20
      CPOS = 2
   10 HOSTCH = C(CPOS)
      UCORD = KARASC(HOSTCH)
      IF ((97 .LE. UCORD) .AND. (UCORD .LE. 122)) UCORD = UCORD - 32
      IF (UCORD .LT. 32) UCORD = 32
      GO TO 30
C
   20 UCORD = -1
      HOSTCH = -1
      NLSNC = EOFERR
C
   30 RETURN
      END
      INTEGER FUNCTION  NLSNLI (INFILE,ERFILE,NLNAME,NUMNAM,NAMES,
     X     DIMLST,ATTNAM,D1,D2,D3,D4,D5,D6,D7,D8,D9,D10,D11,D12,D13,D14,
     X     D15,D16,D17,D18,D19,D20,D21,D22,D23,D24,D25,D26,D27,D28,
     X     D29,D30,D31,D32,D33,D34,D35,D36,D37,D38,D39,D40,D41,D42,
     X     D43,D44,D45,D46,D47,D48,D49,D50,D51,D52,D53,D54,D55,D56,
     X     D57,D58,D59,D60,D61,D62,D63,D64,D65,D66,D67,D68,D69,D70,
     X     D71,D72,D73,D74,D75,D76,D77,D78,D79,D80,D81,D82,D83,D84,
     X     D85,D86,D87,D88,D89,D90,D91,D92,D93,D94,D95,D96,D97,D98,
     X     D99,D100,D101,D102,D103,D104,D105,D106,D107,D108,D109,D110,
     X     D111,D112,D113,D114,D115,D116,D117,D118,D119,D120)
C     (NAMELIST - NAMELIST Input)
C     This routine  provides the  capability for  doing  NAMELIST
C     input on host machines which  do not provide that  facility
C     in FORTRAN.
C
C     The user is  required to provide  via subroutine  arguments
C     the  sort  of  information  automatically  provided  by   a
C     compiler having  the  NAMELIST  capability,  that  is,  the
C     variable names, data types, dimensions, etc.  These are all
C     static attributes  of the  variables.  In  addition, it  is
C     necessary  to  provide  the  run  time  locations  of   all
C     variables.  This is  done be providing  an argument to this
C     subroutine for each item in the NAMELIST group.
C
C     The number of arguments in FORTRAN must be fixed.  This has
C     been set at 60 NAMELIST  variables in the present  routine.
C     This is easily  changed  (up  to a maximum  of 256 for  DEC
C     VAX-11/780 FORTRAN) arguments by adding additional calls to
C     NLSSTV below.
C
C     The function value returned is
C
C     0.......Success
C     1.......Requested NAMELIST data was not found before
C             end-of-file on file INFILE was encountered.
C     2.......NAMELIST data syntax error, unknown variable name,
C             etc.
C
C
C     =====================
C     Argument Descriptions
C     =====================
C
C     INFILE.......File from which NAMELIST data will be read.
C     ERFILE.......File on  which  to write  error  messages.  If
C                  0,  messages  are  suppressed.    Considerable
C                  effort is expended to write informative  error
C                  messages,  so  setting  ERFILE  =  0  is   not
C                  recommended.
C     NLNAME.......NAMELIST group name (in 6H-format).
C     NUMNAM.......Number of items (names) in the NAMELIST group.
C     NAMES(*).....Vector of length NUMNAM giving the names (in
C                  7H-format) of  the NAMELIST  items.   NAMES(*)
C                  should be  declared  DOUBLE  PRECISION.   Each
C                  entry  must  be  able  to  hold  at  least   7
C                  characters; six  are  used  for  the  variable
C                  name, and the seventh is a trailing blank used
C                  to guarantee name uniqueness.
C     DIMLST(*)....An    INTEGER   array   containing   dimension
C                  declarations  for  multi-dimensional   arrays.
C                  For  each  N-dimensional  array,  there  is  a
C                  sequence of N+1 values:  -N, Dim1, Dim2,  ...,
C                  DimN.  ATTNAM(*) contains  pointers into  this
C                  array.  The first entry in each sublist is the
C                  negative of the dimension  count; the sign  is
C                  used for  additional  safety in  decoding  the
C                  list.
C
C     ATTNAM(*)....An INTEGER descriptor vector containing type
C                  and (linear)  dimension information  for  each
C                  item in vector NAMES(*).   A scalar or  vector
C                  entry in ATTNAM(*) has the form
C
C                  (Array Size)*10 + (Data Type Code)
C
C                  A multi-dimensional array entry in ATTNAM(*)
C                  is flagged by a negative value
C
C                  -((Index in DIMLST(*))*10 + (Data Type Code))
C
C                  Only  the  following   data  type  codes   are
C                  supported:
C
C                  0 (TYPLOG) - LOGICAL
C                  1 (TYPINT) - INTEGER
C                  2 (TYPSGL) - REAL
C                  3 (TYPDBL) - DOUBLE PRECISION
C                  4 (TYPCPX) - COMPLEX
C                  5 (TYPHOL) - HOLLERITH STRING (see remarks
C                               below)
C
C                  (Array Size) is the  number of words  reserved
C                  for the vector.  If it is 0, the variable is a
C                  scalar.  Rigorous bounds checking is performed
C                  to avoid input causing memory overwrite.
C
C     D1-D60.......NAMELIST variables in the same order as
C                  specified in the vector NAMES(*).
C
C
C     =====================
C     Remarks on Data Types
C     =====================
C
C     TYPHOL (Type  Hollerith) is  special in  that input  string
C     constants are marked with that attribute, but may be stored
C     in a variable of any other type.  In such a case, the  last
C     word used is explicitly blank padded to a word boundary.
C
C     It is good practice to  restrict Hollerith data to  INTEGER
C     arrays, although this routine itself violates that for user
C     convenience.  It  does  take  care,  however,  to  use  the
C     portable character primitives for all character  operations
C     to preserve portability.  The reason for the restriction to
C     INTEGER arrays is  that floating-point renormalization  can
C     occur even during assignment  on some machines,  destroying
C     the  stored  bit  pattern,  so  that  types  REAL,   DOUBLE
C     PRECISION, and COMPLEX are eliminated.  Type LOGICAL is not
C     useful  either,  because  the  FORTRAN  numeric  relational
C     operators (.EQ. and .NE.) are  illegal with that type,  and
C     because there exist  machines which store  LOGICAL data  in
C     less than one cell (sometimes in a single bit).
C
C     A variable  explicitly marked  as TYPHOL  in its  ATTNAM(*)
C     entry will be permitted to receive only string constants as
C     data values.   For NAMELIST  output, such  a variable  will
C     always be printed as a string value.
C
C
C     ====================
C     Remarks on Variables
C     ====================
C
C     The variable  names must  be legal  FORTRAN variable  names
C     (characters A..Z, 0..9, the first alphabetic).  Letter case
C     is NOT significant; "ALPHA",  "Alpha", "AlPhA" and  "alpha"
C     are equivalent.  Alphabet extenders allowed in some FORTRAN
C     dialects (dollar, underscore, hash mark) are NOT permitted.
C
C
C     ============
C     Input Syntax
C     ============
C
C     NAMELIST  input  is  available  on  many  host   computers,
C     including large machines produced by IBM, CDC, UNIVAC,  and
C     DEC.  It dates back to the  earlier 1960's on the IBM  709,
C     but is  regrettably not  part of  Standard FORTRAN  (either
C     1966 or  1977).   The  input  syntax  of  this  package  is
C     designed to be compatible with input accepted by the  noted
C     host implementations,  but certain  extensions (for  string
C     input and number bases other  than 10) described below  are
C     also acceptable.
C
C     NAMELIST input groups take the form
C
C     $NAME var1=value, var2=value, var3(sub)=value,
C           var4(sub,sub,sub)=value,value,
C           vark=repeat*value,value,
C     $END
C
C     where the  variables  must  be  one of  the  names  in  the
C     NAMELIST variable list.  The order of the variables in  the
C     input list is of no significance, except that if a variable
C     is  specified  more  than   once,  later  assignments   may
C     overwrite earlier ones.  Blanks  may occur anywhere in  the
C     input, except  embedded  in constants  (other  than  string
C     constants, where  they count  as ordinary  characters).   A
C     comma (or  the terminal  $END) must  follow each  constant;
C     end-of-line does NOT constitute a valid constant separator.
C
C     The NAMELIST name $NAME must ALWAYS begin in column 2 of an
C     input record.   The  dollar  sign in  $NAME  and  $END  may
C     optionally be replaced by an ampersand, and the word  "END"
C     after the dollar sign may optionally be omitted.  Column  1
C     of all input records is ignored, and only columns 2..80 are
C     examined.  Column 80 of record k is considered to logically
C     precede column 2 of record k+1, so that tokens may be split
C     across lines (although this is not recommended for  reasons
C     of readability);  this is  an  extension to  most  NAMELIST
C     implementations,  which  usually   require  tokens  to   be
C     complete on a single record.   The terminal $END may  occur
C     anywhere in the input  character stream (ignoring column  1
C     of course);  it need  not  begin in  column  2 as  in  some
C     NAMELIST implementations.
C
C     Letter case is  ignored in all  character comparisons,  but
C     case is preserved in string constants.
C
C     Scalar  variables  may  NOT  be  subscripted,  and  may  be
C     followed by 0 or 1 constant.
C
C     Array variables may  be subscripted  or unsubscripted.   An
C     unsubscripted  array  variable  is  the  same  as  if   the
C     subscript (1) had been specified.   If a subscript list  is
C     given, it must have either one constant, or exactly as many
C     as the  number  in the  declared  dimension of  the  array.
C     Bounds checking is performed  for ALL subscript  positions,
C     although if only one is given for a multi-dimension  array,
C     the check is against the entire array size, not against the
C     first dimension.  If more  than one constant appears  after
C     an  array  assignment,  the   values  go  into   successive
C     locations of the array.  It  is NOT necessary to input  all
C     elements of an array.
C
C     Any constant  may  optionally  be preceded  by  a  positive
C     (1,2,3,..)  integer  repeat  factor,so  that  25*3.1415  is
C     equivalent to  twenty-five successive  values 3.1415.   The
C     repeat count separator, *, may be preceded and followed  by
C     0 or more blanks.
C
C     All Standard FORTRAN numeric constant forms are acceptable,
C     including exponent letters E, D, and Q (Quadruple precision
C     - IBM  and DEC  VAX).   A numeric  constant assigned  to  a
C     numeric variable  will be  converted to  the type  of  that
C     variable  according  to  the  standard  FORTRAN  rules   of
C     assignment.  In  addition,  two  extensions  from  the  Ada
C     language are permitted:
C
C          Underscores may  be  present BETWEEN  digits  for
C          readability,  and  are  ignored.   Examples   are
C          1_100_347, 3.141_592_65, and 10000_00000.0.
C
C          Number bases in the range 2..16 may be  specified
C          for INTEGER constant values only by prefixing the
C          integer with the base and a # sign, for  example,
C          2#101,   8#77377,   10#2500,   16#3AF4E.    Based
C          integers are  illegal in  exponent fields.   This
C          does NOT permit entry  of arbitrary bit  patterns
C          into  variables,  since  the  accumulated  value,
C          taken as a positive number, must be assignable to
C          an integer variable without overflow.
C
C     Numerical values are accumulated in DOUBLE PRECISION,  then
C     converted to the named variable's  data type.  Values of  0
C     (.TRUE.)   and  1  (.FALSE.)   are  permitted  for  LOGICAL
C     variables; any  other numerical  value is  illegal.   Valid
C     LOGICAL constants are 0,  F, .F., .FALSE.,  1, T, .T.,  and
C     .TRUE..
C
C     String constants may be  input to a  variable of any  type,
C     and will spill into as many  words as necessary (up to  the
C     size  of   the  variable),   with  the   last  word   input
C     automatically being blank padded.  Strings may be delimited
C     by balanced single or double  quote characters, and if  the
C     delimiter character is required in  the string, it must  be
C     doubled, following  the usual  convention.  Thus  'O''hara'
C     and "O'hara" are equivalent, and result in the input of six
C     characters.  The count-prefixed  Hollerith form nnH....  is
C     NOT permitted.
C
C     A string constant which is  split over more than one  input
C     record will NOT contain a  NEWLINE character (ASCII CR  LF,
C     UNIX LF, CDC 000000) corresponding to the line break
C
C     If a  repeat  count is  specified  for a  string  constant,
C     filling resumes at the next cell boundary for each instance
C     of the string.   Thus, input of  the string 'AAAAA'  stores
C     five consecutive  letters into  the variable,  while  5*'A'
C     stores the  letter into  five consecutive  elements,  blank
C     padding each to the word  size.  For example, if there  are
C     four  characters  per  word,  the  variable  will   contain
C     'AbbbAbbbAbbbAbbbAbbb' (b = blank).
C
C     Null items  are  legal, so  that  it is  possible  to  skip
C     elements of an  array.  For  example, 'A(3)=3,,5,6,7'  will
C     enter values  into A(3),  A(5),  A(6), and  A(7),  skipping
C     A(4).  A  null  item  may  have a  repeat  count,  so  that
C     'A(3)=3,3*,7' will input values only into A(3) and A(7).
C
C
C     =============
C     Usage Example
C     =============
C
C       DOUBLE PRECISION NAMES(6),NLNAME
C       INTEGER ATTNAM(6),CODE,DIMLST(3),NIN,DUMMY(1)
C       DOUBLE PRECISION X(10),Y(29,3)
C       LOGICAL FLAG
C       DATA NAMES/1HX,1HY,4HNSYM,1HR,3HMAX,4HFLAG/
C       DATA ATTNAM/103,-13,1,3,1,0/
C       DATA DIMLST/-2,29,3/
C       DATA NLNAME/4HDATA/
C       DATA NIN/5/
C       ... ...
C       CODE = NLSNLI(NIN,NLNAME,6,NAMES,DIMLST,ATTNAM,
C      X       X,Y,NSYM,R,MAX,FLAG,
C      X       DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,
C      X       DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,
C      X       DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,
C      X       DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,
C      X       DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,
C      X       DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY)
C       IF (CODE .EQ. 1) GO TO 10
C       IF (CODE .EQ. 2) GO TO 20
C  C    Come here on end-of-file on NIN.
C  10   ...
C
C  C    Come here on data format errors.
C  20   ...
C
C       for which one might have the input data statements
C
C       $DATA R=3.015,
C             X(1)=3,4,5, Y(6)=0,0,0, Y(1)=10.0,
C             NSYM=2, FLAG=T, Y(17,2)=12*3.14159,
C       $END
C
C
C     ==============
C     Error Handling
C     ==============
C
C     Failure to find the requested NAMELIST data group start  or
C     end will result in a return with function value 1 (EOFERR).
C     Some of the NAMELIST variables  may have been set, but  the
C     error should be considered  grounds for abandoning  further
C     processing.  No end-of-file error message is issued,  since
C     this may be an expected condition.
C
C     Errors in the data formats, unknown names, subscript  range
C     errors, invalid ATTNAM(*) or DIMLST(*) entries, or too many
C     input constants, will result in the program returning  with
C     function  value  2  (SYNERR).   When  a  syntax  error   is
C     detected, an attempt is made to resynchronize the scan  and
C     continue  it  to  the  end   of  the  NAMELIST,  or   until
C     end-of-file is reached,  in an effort  to detect all  input
C     errors in a single pass.  As  is often the case with  error
C     recovery of this  nature, this may  result in errors  being
C     raised for  legal data  if the  scan is  restarted at  what
C     appears to be a variable name but is not.
C
C
C     ===================
C     Future Enhancements
C     ===================
C
C     The data types  offered in this  version are  intentionally
C     restricted to those defined  in the 1966 FORTRAN  Standard.
C     However,  definition  of  new  type  codes  and  new  NLSS*
C     routines called from NLSSTV could straightforwardly provide
C     support of BYTE, INTEGER*2, REAL*16, COMPLEX*16, etc.  data
C     types.  FORTRAN 77  CHARACTER type is  probably not  easily
C     supportable,  since  it  is   illegal  to  pass   CHARACTER
C     arguments to a routine which picks them up as non-CHARACTER
C     data.  If the  host provides  some scheme  for passing  the
C     actual address  of  a  character string,  rather  than  the
C     address of a string descriptor, it may be possible for  the
C     caller to  overcome that  limitation.   One can  of  course
C     still receive  string input  in Hollerith  type arrays  and
C     then copy them to CHARACTER arrays in the calling  program.
C
C
C     ==============
C     Author Credits
C     ==============
C
C     A predecessor, NAME$LIST,  to this package  was written  by
C     Stan Hagstrom at the  National Resource for Computation  in
C     Chemistry,  Lawrence  Berkeley  Laboratory,  Berkeley,   CA
C     (1979) for use on the NRCC VAX-11/780.
C
C     A complete rewrite of the  package was made by the  current
C     author, Nelson H.F.   Beebe, at the  University of Utah  to
C     improve the code structure, to document the package, and to
C     make it  useful on  other machines.   I believe  that  this
C     package provides a convenient and effective solution to the
C     lack of NAMELIST on certain host computers, and may even be
C     worthwhile when the  host implementation  is inadequate  or
C     bug-ridden (as I  have myself  experienced).  Although  its
C     use is not as convenient as a simple NAMELIST statement, it
C     does allow the job to  be done, and even permits  arguments
C     of the calling  subroutine to be  present in the  NAMELIST,
C     something which is forbidden in host implementations.
C
C
C     ==========================
C     Portability Considerations
C     ==========================
C
C     There are two main portability  violations in this code  as
C     detected by the PFORT Verifier.
C
C     1) All arguments are treated internally as arrays, in order
C     that local temporaries not be created.  This works on every
C     machine of which I  am aware, but could  fail on a  machine
C     that did scalar/vector type checking of arguments.
C
C     2) In subroutine NLSSTV, the argument array is declared  of
C     INTEGER type, but can be  any of the supported data  types.
C     This again  should  work on  most  machines, but  could  be
C     foiled by a type checking system.  It is essential that  it
C     work if this  package is  to be used.   NLSSTV employs  the
C     user-specified type flags to pass the argument array on  to
C     a selected subroutine which declares the array argument  to
C     be the required data type and does the value assignment.
C
C     Other features which might cause portability problem are as
C     follows:
C
C     3) It is assumed that a DOUBLE PRECISION variable can  hold
C     at least seven (7)  characters; this is  the case with  all
C     known architectures.  Character  comparisons are done  with
C     the primitive KARCM2 so that case differences are  ignored,
C     and problems from possible floating-point normalization are
C     eliminated.
C
C     4) SUBROUTINE  NLSQST assumes  that LOGICAL,  INTEGER,  and
C     REAL data occupy ONE INTEGER storage cell, and that  DOUBLE
C     PRECISION and COMPLEX occupy two INTEGER cells.  For  those
C     few machines for which  this is not  the case (e.g.  Harris
C     computers), minor  changes  will  be  required.   The  PORT
C     Library Framework routine,  I1MACH, is used  to obtain  the
C     number of characters  which can  be stored  in one  INTEGER
C     cell, but there is  unfortunately no corresponding  routine
C     to determine the capacity of other data types.
C
C     5) It  is assumed  throughout the  package that  a  routine
C     argument can be  dimensioned (1)  when in  fact the  actual
C     dimension may be larger,  and that it  will be possible  to
C     refer  to  elements  beyond   the  first  without   causing
C     compile-time or run-time subscript bound exceptions.
C
C     6) It is assumed  that an INTEGER variable  can be used  to
C     accumulate the index  into any  array.  This  would not  be
C     true, for example, on a 32-bit address machine like the VAX
C     with a  16-bit integer  variable (which  is not  the  VAX's
C     default size).
C
C     7)  Comments  and  Hollerith  strings  contain   lower-case
C     letters; only on CDC  operating systems should it  possibly
C     be  necessary  to   convert  the   source  to   upper-case.
C     Installations with the ASCII or EBCDIC character set should
C     not experience any problem with this.
C
C
C     =======================
C     Programming Conventions
C     =======================
C
C     The  FORTRAN  code  in  this  package  was  written  to  be
C     exemplary.  All variables  are explicitly declared  (thanks
C     to the  Extended PFORT  Verifier).  There  are many  COMMON
C     blocks so that information can be hidden from all but those
C     routines which require access to it.  GO TO jumps do not go
C     backward except  in short  WHILE  loops, the  two  extended
C     loops in  this routine,  and the  restart jumps  in  NLSDFC
C     (taken when a repeat count or number base is decoded); this
C     makes it substantially easier to verify the correct parsing
C     and control flow.
C
C     The parsing  is token-based  without token  lookahead.   In
C     addition,  each  token  parser  expects  the  input  to  be
C     positioned at  the  beginning  of a  new  token,  with  the
C     possible exception of  leading blanks, and  is expected  to
C     advance  the  current  input  character  up  to  the   next
C     delimiter ("=" or "(" after a variable name, and "," or "$"
C     after a constant).
C
C     Character set independence is maintained through use of the
C     machine-independent character  primitives  KARASC,  KARCM2,
C     KARMOV, KARUC, and  KARUPK proposed  by the  author in  the
C     Proceedings of the NRCC Conference on Software Standards in
C     Chemistry (1979).  The parsing  makes extensive use of  the
C     value UCORD left in COMMON by NLSNC (Next Character); it is
C     the upper-case  ASCII ordinal  equivalent of  a host  input
C     character,  unless  the   host  character   is  a   control
C     character, in which case UCORD is the same as for a  blank.
C     This  makes  ASCII  control  characters  such  as  TAB  and
C     FORMFEED equivalent to blanks.   The actual host  character
C     is  available  in  HOSTCH   for  use  in  string   constant
C     collection, where  it  is essential  to  be able  to  input
C     (almost) any host character.  Having the upper-case ordinal
C     available simplifies  letter  comparisons,  and  given  the
C     ASCII ordinal, it is  straightforward to class a  character
C     as letter,  digit,  etc.,  as  well  as  to  determine  its
C     possible  value   as  a   digit.    KARCM2  is   used   for
C     case-independent  string  comparisons;  its  comparison  is
C     defined to be in the ASCII collating sequence, but for  the
C     purposes of this routine, only  a test for string  equality
C     is required.
C     (18-APR-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       IABS,        KARASC,      KARCM2
C     EXTERNAL REFS       KARUC,       MAX0,        NLSFLI,      NLSGNB
C     EXTERNAL REFS       NLSGTS,      NLSNC,       NLSRR,       NLSSTV
C     EXTERNAL REFS       NLSTOK,      NLSWBC,      NLSWEM,      NLSWEV
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             KARASC,      KARCM2,      KARUC,       NLSFLI
      INTEGER             NLSGNB,      NLSGTS,      NLSNC,       NLSRR
      INTEGER             NLSTOK
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             IABS,        MAX0
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             ISDOLL
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     RUNTIME DIMENSION VARIABLES
C
      INTEGER             NUMNAM
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CODE,        DIMVEC,      I,           IT
C     SETS                J,           LSTERR,      LSTPTR,      NDIM
C     SETS                NLNLEN,      NLNORD,      NV
C
      DOUBLE PRECISION    NAMES(NUMNAM)
      INTEGER             ARG,         ATTNAM(NUMNAM),           CODE
      INTEGER             D1(1),       D10(1),      D11(1),      D12(1)
      INTEGER             D13(1),      D14(1),      D15(1),      D16(1)
      INTEGER             D17(1),      D18(1),      D19(1),      D2(1)
      INTEGER             D20(1),      D21(1),      D22(1),      D23(1)
      INTEGER             D24(1),      D25(1),      D26(1),      D27(1)
      INTEGER             D28(1),      D29(1),      D3(1),       D30(1)
      INTEGER             D31(1),      D32(1),      D33(1),      D34(1)
      INTEGER             D35(1),      D36(1),      D37(1),      D38(1)
      INTEGER             D39(1),      D4(1),       D40(1),      D41(1)
      INTEGER             D42(1),      D43(1),      D44(1),      D45(1)
      INTEGER             D46(1),      D47(1),      D48(1),      D49(1)
      INTEGER             D5(1),       D50(1),      D51(1),      D52(1)
      INTEGER             D53(1),      D54(1),      D55(1),      D56(1)
      INTEGER             D57(1),      D58(1),      D59(1),      D6(1)
      INTEGER             D60(1),      D7(1),       D8(1),       D9(1)
      INTEGER D61(1),D62(1),D63(1),D64(1),D65(1),D66(1),D67(1),D68(1),
     X        D69(1),D70(1),D71(1),D72(1),D73(1),D74(1),D75(1),D76(1),
     X        D77(1),D78(1),D79(1),D80(1),D81(1),D82(1),D83(1),D84(1),
     X        D85(1),D86(1),D87(1),D88(1),D89(1),D90(1),D91(1),D92(1),
     X        D93(1),D94(1),D95(1),D96(1),D97(1),D98(1),D99(1),D100(1),
     X        D101(1),D102(1),D103(1),D104(1),D105(1),D106(1),D107(1),
     X        D108(1),D109(1),D110(1),D111(1),D112(1),D113(1),D114(1),
     X        D115(1),D116(1),D117(1),D118(1),D119(1),D120(1)
      INTEGER             DIMLST(1),   DIMVEC(1),   DUMMY,       ERFILE
      INTEGER             I,           INFILE,      IT,          J
      INTEGER             LSTERR,      LSTPTR,      MODE,        NDIM
      INTEGER             NLNAME(1),   NLNLEN,      NLNORD(8),   NSUB
      INTEGER             NV,          VNAME(8)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS01  /
C
C     UNUSED              VCPX,        VDBL,        VLOG
C
C     SETS                NREL,        NRELMX,      VARTYP
C
      DOUBLE PRECISION    VDBL
      COMPLEX             VCPX
      INTEGER             VARTYP,      NREL,        NRELMX,      NREP
      LOGICAL             VLOG
      COMMON / NLS01  /   VCPX,        VDBL,        VLOG,        VARTYP
      COMMON / NLS01  /   NREL,        NRELMX,      NREP
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS02  /
C
      INTEGER             UCORD
      COMMON / NLS02  /   UCORD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
C     SETS                EOFERR,      OKAY,        SYNERR
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS05  /
C
C     UNUSED              STRING
C
C     SETS                LENQST
C
      INTEGER             LENQST,      STRING
      COMMON / NLS05  /   LENQST,      STRING(256)
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS06  /
C
C     SETS                TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
C     SETS                TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
C     SETS                TYPVAR
C
      INTEGER             TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
      INTEGER             TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
      INTEGER             TYPVAR
      COMMON / NLS06  /   TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
      COMMON / NLS06  /   TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
      COMMON / NLS06  /   TYPVAR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS07  /
C
C     SETS                AMPSND,      BLANK,       COMMA,       DOLLAR
C     SETS                DQUOTE,      EQUALS,      HASHMK,      LPAREN
C     SETS                MINUS,       PERIOD,      PLUS,        RPAREN
C     SETS                SQUOTE,      STAR,        UCD,         UCE
C     SETS                UCF,         UCQ,         UCT,         USCORE
C
      INTEGER             AMPSND,      BLANK,       COMMA,       DOLLAR
      INTEGER             DQUOTE,      EQUALS,      HASHMK,      LPAREN
      INTEGER             MINUS,       PERIOD,      PLUS,        RPAREN
      INTEGER             SQUOTE,      STAR,        UCD,         UCE
      INTEGER             UCF,         UCQ,         UCT,         USCORE
      COMMON / NLS07  /   AMPSND,      BLANK,       COMMA,       DOLLAR
      COMMON / NLS07  /   DQUOTE,      EQUALS,      HASHMK,      LPAREN
      COMMON / NLS07  /   MINUS,       PERIOD,      PLUS,        RPAREN
      COMMON / NLS07  /   SQUOTE,      STAR,        UCD,         UCE
      COMMON / NLS07  /   UCF,         UCQ,         UCT,         USCORE
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS08  /
C
C     UNUSED              C,           CPOS
C
C     SETS                LINENO
C
      INTEGER             LINENO,      CPOS,        C
      COMMON / NLS08  /   LINENO,      CPOS,        C(80)
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS09  /
C
C     SETS                ERUNIT,      INUNIT
C
      INTEGER             ERUNIT,      INUNIT
      COMMON / NLS09  /   ERUNIT,      INUNIT
C
      ISDOLL(ARG) = (ARG .EQ. DOLLAR) .OR. (ARG .EQ. AMPSND)
C
C     Define function return  values in COMMON  in order to  have
C     symbolic names  for  them instead  of  meaningless  integer
C     values.
C
      OKAY = 0
      EOFERR = 1
      SYNERR = 2
      LSTERR = OKAY
C
C     Initialize character  symbolic  constants  in  COMMON  with
C     their ASCII ordinal values.   In addition to these,  NLSTOK
C     declares ASCII  values  for the  strings  ".F.",  ".FALSE."
C     ".T.", ".TRUE." and "END".  Since NLSNC always provides the
C     upper-case ASCII  ordinal  equivalent  of  the  next  input
C     character,  character-set  independence  and  letter   case
C     equality is preserved across  all hosts, the details  being
C     concealed entirely inside the portable character  primitive
C     KARASC.
C
      AMPSND = 38
      BLANK = 32
      COMMA = 44
      DOLLAR = 36
      DQUOTE = 34
      EQUALS = 61
      HASHMK = 35
      LPAREN = 40
      MINUS = 45
      PERIOD = 46
      PLUS = 43
      RPAREN = 41
      SQUOTE = 39
      STAR = 42
      UCD = 68
      UCE = 69
      UCF = 70
      UCQ = 81
      UCT = 84
      USCORE = 95
C
C     Initialize data type symbolic  constants in COMMON.   These
C     must  match   the   type  flags   encoded   in   ATTNAM(*).
C     Non-negative values are reserved for FORTRAN data types  on
C     the host, and unless the  packing in ATTNAM(*) is  changed,
C     will be restricted to values 0..9.  Negative values may  be
C     used internally.  No  assumption is made  anywhere in  this
C     package  about  the  relative  numeric  orderings  of   the
C     different constants,  so  that  changes  in  the  following
C     assignment statements will  be transparent to  the rest  of
C     the package.
C
C     TYPNUL is not actually  a data type; it  is used by  NLSTOK
C     (Get Value) to indicate that  a null value was input  (e.g.
C     X=,).
C
C     TYPEND is also not  a data type, but  is used by NLSTOK  to
C     signal that $END was encountered instead of a data value.
C
      TYPVAR = -3
      TYPNUL = -2
      TYPE ND = -1
      TYPLOG = 0
      TYPINT = 1
      TYPSGL = 2
      TYPDBL = 3
      TYPCPX = 4
      TYPHOL = 5
C
C     Initialize miscellaneous values in COMMON.
C
      LENQST = 0
      LINENO = 0
      INUNIT = INFILE
      ERUNIT = ERFILE
C
C     Convert the NAMELIST group  name to an  array of its  ASCII
C     equivalents, with  NLNLEN set  to the  index of  the  first
C     blank following the name.  This is used to ensure a  unique
C     match when the name is searched for in the input stream.
C
           DO 10 J = 1,8
           I = 9 - J
           CALL KARMOV (IT,1,NLNAME,I,1)
           NLNORD(I) = KARASC(KARUC(IT))
           IF (NLNORD(I) .EQ. BLANK) NLNLEN = I
   10      CONTINUE
      IF (NLNLEN .LE. 1) GO TO 850
C
C     Flush the input stream until $NAME is encountered beginning
C     in column 2.
C
   20 IF (NLSRR(DUMMY) .EQ. EOFERR) GO TO 880
      CODE = NLSNC (DUMMY)
      IF (.NOT.ISDOLL(UCORD)) GO TO 20
           DO 30 I = 1,NLNLEN
           CODE = NLSNC (DUMMY)
           IF (UCORD .NE. NLNORD(I)) GO TO 20
   30      CONTINUE
C
C     Initialize the variable  input loop.   NLSTOK collects  the
C     next token in the input stream, and signals an error if the
C     token is not a valid  token, or if end-of-file is  reached.
C     Control returns  to the  name table  search code  following
C     each time an input token of type TYPVAR is found by NLSTOK.
C     The inner loop collects one  or more constants for  storage
C     in the current variable.
C
      CODE = NLSTOK (MODE,VNAME)
      IF (CODE .EQ. SYNERR) GO TO 890
      IF (CODE .EQ. EOFERR) GO TO 800
      IF (MODE .EQ. TYPEND) GO TO 870
      IF (MODE .NE. TYPVAR) GO TO 810
C
C     We have  a variable  name.   Search the  name table  for  a
C     match.
C
   40      DO 50 J = 1,NUMNAM
           IT = J
           IF (KARCM2(NAMES(IT),1,VNAME,1,7) .EQ. 0) GO TO 60
   50      CONTINUE
      GO TO 790
C
C     NRELMX is  the  dimension  limit of  the  array  or  scalar
C     variable.  VARTYP is its type  code.  NREL is the offset  index
C     into the array.   It is initially  zero (implying a  scalar
C     variable), but is reset to an array index when a  subscript
C     is decoded.  LSTPTR  points to  the list  (-N, Dim1,  Dim2,
C     ..., DimN) in DIMLST(*).
C
   60 IF (ATTNAM(IT) .GE. 0) GO TO 80
      LSTPTR = IABS(ATTNAM(IT))/10
      VARTYP = IABS(ATTNAM(IT)) - LSTPTR*10
      NDIM = -DIMLST(LSTPTR)
      IF (NDIM .LE. 0) GO TO 860
      NRELMX = 1
           DO 70 I = 1,NDIM
           J = LSTPTR + I
           IF (DIMLST(J) .LE. 0) GO TO 860
   70      NRELMX = NRELMX*DIMLST(J)
      GO TO 90
   80 NRELMX = ATTNAM(IT)/10
      VARTYP = ATTNAM(IT)-NRELMX*10
      LSTPTR = 0
      DIMVEC(1) = NRELMX
   90 NREL = 0
C
C     Verify that the variable type code is legal.
C
      IF (.NOT.((VARTYP .EQ. TYPLOG) .OR. (VARTYP .EQ. TYPINT) .OR.
     X     (VARTYP .EQ. TYPDBL) .OR. (VARTYP .EQ. TYPSGL) .OR.(VARTYP
     X     .EQ. TYPCPX) .OR. (VARTYP .EQ. TYPHOL))) GO TO 830
      IF (UCORD .EQ. EQUALS) GO TO 100
      IF (UCORD .NE. LPAREN) GO TO 820
C
C     Start of parenthesized subscript list.   It is an error  if
C     this  variable  is  a  scalar.   Otherwise,  evaluate   the
C     subscript to get a single relative index in the array.
C
      IF (NRELMX .EQ. 0) GO TO 770
      IF (LSTPTR .NE. 0) CODE = NLSGTS (NSUB,NDIM,DIMLST(LSTPTR+1))
      IF (LSTPTR .EQ. 0) CODE = NLSGTS (NSUB,1,DIMVEC)
      IF (CODE .EQ. SYNERR) GO TO 890
      IF (CODE .EQ. EOFERR) GO TO 880
      NREL = NSUB
C
C     At this  point,  we are  positioned  at the  closing  right
C     parenthesis  following  the   subscript  list.  Flush   any
C     trailing blanks to reach the expected equals sign.
C
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 880
      CODE = NLSGNB (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 880
      IF (UCORD .NE. EQUALS) GO TO 820
C
C     The current character is an equals sign; advance past it to
C     the beginning of the constant list.
C
  100 CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 880
C
C     NV counts the number of input  data values.  It is used  to
C     check that no more than one value is supplied for a  scalar
C     variable.
C
      NV = 0
C
C     Start of  input  value  sequence  loop.   For  the  current
C     variable,  we  return  here  after  processing  the   input
C     constant.  Exit occurs  when NLSTOK  returns either  TYPVAR
C     (variable name) or TYPEND ($END encountered).
C
  110 CODE = NLSTOK (MODE,VNAME)
      IF (CODE .EQ. SYNERR) GO TO 890
      IF (CODE .EQ. EOFERR) GO TO 880
      IF (MODE .EQ. TYPEND) GO TO 870
      IF (MODE .EQ. TYPVAR) GO TO 760
      IF (MODE .NE. TYPNUL) GO TO 120
C
C     Null data  item.   Advance  NREL according  to  the  repeat
C     count.
C
      NREL = MAX0(1,NREL) + NREP
      GO TO 750
C
C     We are now ready to store the input value in the  variable.
C     Is it an array variable or a scalar variable?
C
  120 IF (NRELMX .EQ. 0) GO TO 130
C
C     Array variable.  Set index to 1 if currently 0, then  check
C     against the dimension  limit before  assigning the  current
C     values.
C
      NREL = MAX0(1,NREL)
      IF ((NREL + NREP - 1) .LE. NRELMX) GO TO 140
      GO TO 840
C
C     Scalar variable.   Check that  only one  constant has  been
C     input before  assigning the  current value,  and make  sure
C     that it is not subscripted.
C
  130 IF (NV .NE. 0) GO TO 780
      IF (NREP .GT. 1) GO TO 780
      IF (NREL .NE. 0) GO TO 770
C
C     Call NLSSTV to do the  assignment for the current  variable.
C     This jump table is ugly but necessary in FORTRAN.
C
  140 GO TO (150,160,170,180,190,200,210,220,230,240,250,260,270,280,
     X     290,300,310,320,330,340,350,360,370,380,390,400,410,420,430,
     X     440,450,460,470,480,490,500,510,520,530,540,550,560,570,580,
     X     590,600,610,620,630,640,650,660,670,680,690,700,710,720,730,
     X     740,74061,74062,74063,74064,74065,74066,74067,74068,74069,
     X     74070,74071,74072,74073,74074,74075,74076,74077,74078,74079,
     X     74080,74081,74082,74083,74084,74085,74086,74087,74088,74089,
     X     74090,74091,74092,74093,74094,74095,74096,74097,74098,74099,
     X     74100,74101,74102,74103,74104,74105,74106,74107,74108,74109,
     X     74110,74111,74112,74113,74114,74115,74116,74117,74118,74119,
     X     74120),IT
  150 CALL NLSSTV (D1)
      GO TO 750
  160 CALL NLSSTV (D2)
      GO TO 750
  170 CALL NLSSTV (D3)
      GO TO 750
  180 CALL NLSSTV (D4)
      GO TO 750
  190 CALL NLSSTV (D5)
      GO TO 750
  200 CALL NLSSTV (D6)
      GO TO 750
  210 CALL NLSSTV (D7)
      GO TO 750
  220 CALL NLSSTV (D8)
      GO TO 750
  230 CALL NLSSTV (D9)
      GO TO 750
  240 CALL NLSSTV (D10)
      GO TO 750
  250 CALL NLSSTV (D11)
      GO TO 750
  260 CALL NLSSTV (D12)
      GO TO 750
  270 CALL NLSSTV (D13)
      GO TO 750
  280 CALL NLSSTV (D14)
      GO TO 750
  290 CALL NLSSTV (D15)
      GO TO 750
  300 CALL NLSSTV (D16)
      GO TO 750
  310 CALL NLSSTV (D17)
      GO TO 750
  320 CALL NLSSTV (D18)
      GO TO 750
  330 CALL NLSSTV (D19)
      GO TO 750
  340 CALL NLSSTV (D20)
      GO TO 750
  350 CALL NLSSTV (D21)
      GO TO 750
  360 CALL NLSSTV (D22)
      GO TO 750
  370 CALL NLSSTV (D23)
      GO TO 750
  380 CALL NLSSTV (D24)
      GO TO 750
  390 CALL NLSSTV (D25)
      GO TO 750
  400 CALL NLSSTV (D26)
      GO TO 750
  410 CALL NLSSTV (D27)
      GO TO 750
  420 CALL NLSSTV (D28)
      GO TO 750
  430 CALL NLSSTV (D29)
      GO TO 750
  440 CALL NLSSTV (D30)
      GO TO 750
  450 CALL NLSSTV (D31)
      GO TO 750
  460 CALL NLSSTV (D32)
      GO TO 750
  470 CALL NLSSTV (D33)
      GO TO 750
  480 CALL NLSSTV (D34)
      GO TO 750
  490 CALL NLSSTV (D35)
      GO TO 750
  500 CALL NLSSTV (D36)
      GO TO 750
  510 CALL NLSSTV (D37)
      GO TO 750
  520 CALL NLSSTV (D38)
      GO TO 750
  530 CALL NLSSTV (D39)
      GO TO 750
  540 CALL NLSSTV (D40)
      GO TO 750
  550 CALL NLSSTV (D41)
      GO TO 750
  560 CALL NLSSTV (D42)
      GO TO 750
  570 CALL NLSSTV (D43)
      GO TO 750
  580 CALL NLSSTV (D44)
      GO TO 750
  590 CALL NLSSTV (D45)
      GO TO 750
  600 CALL NLSSTV (D46)
      GO TO 750
  610 CALL NLSSTV (D47)
      GO TO 750
  620 CALL NLSSTV (D48)
      GO TO 750
  630 CALL NLSSTV (D49)
      GO TO 750
  640 CALL NLSSTV (D50)
      GO TO 750
  650 CALL NLSSTV (D51)
      GO TO 750
  660 CALL NLSSTV (D52)
      GO TO 750
  670 CALL NLSSTV (D53)
      GO TO 750
  680 CALL NLSSTV (D54)
      GO TO 750
  690 CALL NLSSTV (D55)
      GO TO 750
  700 CALL NLSSTV (D56)
      GO TO 750
  710 CALL NLSSTV (D57)
      GO TO 750
  720 CALL NLSSTV (D58)
      GO TO 750
  730 CALL NLSSTV (D59)
      GO TO 750
  740 CALL NLSSTV (D60)
      GO TO 750
74061 CALL NLSSTV (D61)
      GO TO 750
74062 CALL NLSSTV (D62)
      GO TO 750
74063 CALL NLSSTV (D63)
      GO TO 750
74064 CALL NLSSTV (D64)
      GO TO 750
74065 CALL NLSSTV (D65)
      GO TO 750
74066 CALL NLSSTV (D66)
      GO TO 750
74067 CALL NLSSTV (D67)
      GO TO 750
74068 CALL NLSSTV (D68)
      GO TO 750
74069 CALL NLSSTV (D69)
      GO TO 750
74070 CALL NLSSTV (D70)
      GO TO 750
74071 CALL NLSSTV (D71)
      GO TO 750
74072 CALL NLSSTV (D72)
      GO TO 750
74073 CALL NLSSTV (D73)
      GO TO 750
74074 CALL NLSSTV (D74)
      GO TO 750
74075 CALL NLSSTV (D75)
      GO TO 750
74076 CALL NLSSTV (D76)
      GO TO 750
74077 CALL NLSSTV (D77)
      GO TO 750
74078 CALL NLSSTV (D78)
      GO TO 750
74079 CALL NLSSTV (D79)
      GO TO 750
74080 CALL NLSSTV (D80)
      GO TO 750
74081 CALL NLSSTV (D81)
      GO TO 750
74082 CALL NLSSTV (D82)
      GO TO 750
74083 CALL NLSSTV (D83)
      GO TO 750
74084 CALL NLSSTV (D84)
      GO TO 750
74085 CALL NLSSTV (D85)
      GO TO 750
74086 CALL NLSSTV (D86)
      GO TO 750
74087 CALL NLSSTV (D87)
      GO TO 750
74088 CALL NLSSTV (D88)
      GO TO 750
74089 CALL NLSSTV (D89)
      GO TO 750
74090 CALL NLSSTV (D90)
      GO TO 750
74091 CALL NLSSTV (D91)
      GO TO 750
74092 CALL NLSSTV (D92)
      GO TO 750
74093 CALL NLSSTV (D93)
      GO TO 750
74094 CALL NLSSTV (D94)
      GO TO 750
74095 CALL NLSSTV (D95)
      GO TO 750
74096 CALL NLSSTV (D96)
      GO TO 750
74097 CALL NLSSTV (D97)
      GO TO 750
74098 CALL NLSSTV (D98)
      GO TO 750
74099 CALL NLSSTV (D99)
      GO TO 750
74100 CALL NLSSTV (D100)
      GO TO 750
74101 CALL NLSSTV (D101)
      GO TO 750
74102 CALL NLSSTV (D102)
      GO TO 750
74103 CALL NLSSTV (D103)
      GO TO 750
74104 CALL NLSSTV (D104)
      GO TO 750
74105 CALL NLSSTV (D105)
      GO TO 750
74106 CALL NLSSTV (D106)
      GO TO 750
74107 CALL NLSSTV (D107)
      GO TO 750
74108 CALL NLSSTV (D108)
      GO TO 750
74109 CALL NLSSTV (D109)
      GO TO 750
74110 CALL NLSSTV (D110)
      GO TO 750
74111 CALL NLSSTV (D111)
      GO TO 750
74112 CALL NLSSTV (D112)
      GO TO 750
74113 CALL NLSSTV (D113)
      GO TO 750
74114 CALL NLSSTV (D114)
      GO TO 750
74115 CALL NLSSTV (D115)
      GO TO 750
74116 CALL NLSSTV (D116)
      GO TO 750
74117 CALL NLSSTV (D117)
      GO TO 750
74118 CALL NLSSTV (D118)
      GO TO 750
74119 CALL NLSSTV (D119)
      GO TO 750
74120 CALL NLSSTV (D120)
      GO TO 750
C
  750 NV = NV + NREP
C
C     End of input value sequence loop; go back for next value.
C
      GO TO 110
C
C     End of input variable loop.
C
  760 GO TO 40
C
C     Error message and termination section.
C
  770 CALL NLSWEV (36HIllegal to subscript scalar variable,36,VNAME)
      GO TO 890
  780 CALL NLSWEV (
     X     51HMore than one constant supplied for scalar variable,51,
     X     VNAME)
      GO TO 890
  790 CALL NLSWEV (34HNAMELIST does not contain variable,34,VNAME)
      GO TO 890
  800 CALL NLSWEM (22HNAMELIST expected $END,22)
      GO TO 890
  810 CALL NLSWEV (
     X     66HNAMELIST expected variable name or $END but found constant
     X instead,66,VNAME)
      GO TO 890
  820 CALL NLSWEV (
     X     51HNAMELIST expects "=" or "(" following variable name,51,
     X     VNAME)
      GO TO 890
  830 CALL NLSWEM (45HData type code in ATTNAM(*) out of range 0..5,45)
      GO TO 890
  840 CALL NLSWEV (34HToo many input constants for array,34,VNAME)
      GO TO 890
  850 CALL NLSWEM (33HIllegal blank NAMELIST group name,33)
      GO TO 890
  860 CALL NLSWEV (49HIllegal array dimension descriptor list for array,
     X     49,VNAME)
      GO TO 890
C
  870 NLSNLI = LSTERR
      GO TO 910
C
  880 NLSNLI = EOFERR
      GO TO 910
C
C     For a  syntax error,  resynchronize the  input by  flushing
C     past the next comma and forward to the first possibly legal
C     variable name, but  stopping if  a possible  name is  found
C     preceded by a blank, then restart the major loop.  In  this
C     way, multiple input  errors will  be detected  on one  run.
C     The error  is  remembered so  that  we return  the  correct
C     function value.
C
  890 CALL NLSWBC
      LSTERR = SYNERR
      CODE = NLSFLI(DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 880
  900 CODE = NLSTOK (MODE,VNAME)
      IF (CODE .EQ. EOFERR) GO TO 880
      IF (MODE .EQ. TYPEND) GO TO 870
      IF (MODE .EQ. TYPVAR) GO TO 40
      GO TO 900
C
  910 RETURN
      END
      INTEGER FUNCTION  NLSQST (DUMMY)
C     (NAMELIST - Quoted String)
C     Extract a quoted string  and store it  in COMMON for  later
C     assignment to a variable.  The string length is limited  to
C     256*(number of host  characters/word) characters, which  is
C     determined by the size of the string buffer in COMMON.
C
C     On entry,  the current  character  position is  assumed  to
C     contain the opening quote  (either single or double).   The
C     scan will  continue until  a  matching quote  character  is
C     found.  In this way, the  caller can decide what the  quote
C     character really is.
C
C     Embedded doubled adjacent quotes matching the opening quote
C     will be collapsed into single quotes, and will not count as
C     a string terminator.  Trailing  blanks are flushed and  the
C     input is positioned  after the  delimiting comma,  or at  a
C     dollar.  On return, the  function value is OKAY  (success),
C     SYNERR (syntax error), or EOFERR (end-of-file).
C     (18-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       I1MACH,      KARMOV,      MIN0,        NLSCKD
C     EXTERNAL REFS       NLSNC,       NLSWEM
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             I1MACH,      NLSCKD,      NLSNC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MIN0
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CODE,        MAXQST,      NCHPWD,      QUOTE
C
      INTEGER             CODE,        DUMMY,       MAXQST,      NCHPWD
      INTEGER             QUOTE
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS02  /
C
      INTEGER             UCORD
      COMMON / NLS02  /   UCORD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS03  /
C
      INTEGER             HOSTCH
      COMMON / NLS03  /   HOSTCH
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS05  /
C
C     SETS                LENQST
C
      INTEGER             LENQST,      STRING
      COMMON / NLS05  /   LENQST,      STRING(256)
C
      DATA                MAXQST/256/
C
      NCHPWD = I1MACH(6)
C
C     Save opening quote character.
C
      QUOTE = UCORD
      LENQST = 0
   10 CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 70
      IF (UCORD .NE. QUOTE) GO TO 20
C
C     Quote found.  Is it a doubled quote?
C
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 70
      IF (UCORD .NE. QUOTE) GO TO 30
C
C     Non-delimiter character or collapsed quote pair to be saved.
C
   20 LENQST = LENQST + 1
      CALL KARMOV (STRING,MIN0(MAXQST*NCHPWD,LENQST),HOSTCH,1,1)
      GO TO 10
C
C     A string constant was successfully parsed.  Now position
C     past the delimiter.
C
   30 CODE = NLSCKD (DUMMY)
      IF (CODE .EQ. SYNERR) GO TO 40
      IF (CODE .EQ. EOFERR) GO TO 70
C
C     Termination and error message section.
C
      IF (LENQST .GT. (MAXQST*NCHPWD)) GO TO 50
      NLSQST = OKAY
      GO TO 80
C
   40 CALL NLSWEM (
     X     51HValid string constant followed by illegal delimiter,51)
      GO TO 60
   50 CALL NLSWEM (
     X     54HInput quoted string truncated at internal buffer limit,54)
   60 NLSQST = SYNERR
      GO TO 80
C
   70 NLSQST = EOFERR
      LENQST = 0
C
   80 RETURN
      END
      INTEGER FUNCTION  NLSRR (DUMMY)
C     (NAMELIST - Read Record)
C     Read a single record from the input file into the  unpacked
C     text buffer,  C(*), in  COMMON.  The  function returned  is
C     OKAY on success,  and EOFERR on  end-of-file.  The  current
C     character position, CPOS in COMMON, is set to 1 so that the
C     next call to NLSNC will begin with the character in  column
C     2.
C     (13-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     UNUSED              DUMMY
C
      INTEGER             DUMMY
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
C     UNUSED              SYNERR
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS08  /
C
C     SETS                C,           CPOS,        LINENO
C
      INTEGER             LINENO,      CPOS,        C
      COMMON / NLS08  /   LINENO,      CPOS,        C(80)
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS09  /
C
C     UNUSED              ERUNIT
C
      INTEGER             ERUNIT,      INUNIT
      COMMON / NLS09  /   ERUNIT,      INUNIT
C
      CPOS = 1
      READ (INUNIT,1000,END = 10) C
      LINENO = LINENO + 1
      NLSRR = OKAY
      GO TO 20
C
   10 NLSRR = EOFERR
C
   20 RETURN
C
 1000 FORMAT (80A1)
      END
      SUBROUTINE  NLSSC (C)
C     (NAMELIST - Store COMPLEX)
C     Store in C(n) the current input value(s), updating NREL  in
C     COMMON to the next available position.
C     (10-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       MAX0
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MAX0
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                C,           I
C
      COMPLEX             C(1)
      INTEGER             I
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS01  /
C
C     UNUSED              NRELMX,      VARTYP,      VDBL,        VLOG
C
C     SETS                NREL
C
      DOUBLE PRECISION    VDBL
      COMPLEX             VCPX
      INTEGER             VARTYP,      NREL,        NRELMX,      NREP
      LOGICAL             VLOG
      COMMON / NLS01  /   VCPX,        VDBL,        VLOG,        VARTYP
      COMMON / NLS01  /   NREL,        NRELMX,      NREP
C
      NREL = MAX0(1,NREL)
           DO 10 I = 1,NREP
           C(NREL) = VCPX
   10      NREL = NREL + 1
C
      RETURN
      END
      SUBROUTINE  NLSSD (D)
C     (NAMELIST - Store DOUBLE PRECISION)
C     Store in D(n) the current input value(s), updating NREL  in
C     COMMON to the next available position.
C     (10-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       MAX0
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MAX0
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                D,           I
C
      DOUBLE PRECISION    D(1)
      INTEGER             I
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS01  /
C
C     UNUSED              NRELMX,      VARTYP,      VCPX,        VLOG
C
C     SETS                NREL
C
      DOUBLE PRECISION    VDBL
      COMPLEX             VCPX
      INTEGER             VARTYP,      NREL,        NRELMX,      NREP
      LOGICAL             VLOG
      COMMON / NLS01  /   VCPX,        VDBL,        VLOG,        VARTYP
      COMMON / NLS01  /   NREL,        NRELMX,      NREP
C
      NREL = MAX0(1,NREL)
           DO 10 I = 1,NREP
           D(NREL) = VDBL
   10      NREL = NREL + 1
C
      RETURN
      END
      SUBROUTINE  NLSSH (UNSPEC)
C     (NAMELIST - Store Hollerith String)
C     Store a string  value in  the array  UNSPEC(*).  The  array
C     data type, VARTYP, index, NREL, and size, NRELMX, in COMMON are
C     used to  prevent storage  overflow.  The  string is  copied
C     into the array  beginning at the  current index, NREL,  and
C     the last word modified is blank filled to a cell  boundary.
C     If there is insufficient space for the string, it is simply
C     truncated without raising an error condition.
C
C     If a repeat  count was  specified, filling  resumes at  the
C     next cell boundary  for each  instance of  the string.   On
C     return, LENQST is reset to 0 to prevent re-entry until  the
C     next string is  input, and NREL  is reset to  point to  the
C     last cell  modified,  so  that if  this  routine  is  later
C     re-entered with  a  value  from  the  same  constant  list,
C     filling will resume correctly.
C     (17-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       I1MACH,      KARMOV,      MAX0,        MIN0
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             I1MACH
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MAX0,        MIN0
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C                      HOLLERITH STRING VARIABLES
C
      INTEGER             SPACE
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                DOUBLE,      I,           LAST,        LIMIT
C     SETS                NCELLS,      NCHPWD,      OFFSET,      UNSPEC
C
      INTEGER             I,           LAST,        LIMIT
      INTEGER             NCELLS,      NCHPWD,      OFFSET
      INTEGER             UNSPEC(1)
      LOGICAL             DOUBLE
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS01  /
C
C     UNUSED              VCPX,        VDBL,        VLOG
C
C     SETS                NREL
C
      DOUBLE PRECISION    VDBL
      COMPLEX             VCPX
      INTEGER             VARTYP,      NREL,        NRELMX,      NREP
      LOGICAL             VLOG
      COMMON / NLS01  /   VCPX,        VDBL,        VLOG,        VARTYP
      COMMON / NLS01  /   NREL,        NRELMX,      NREP
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS05  /
C
C     SETS                LENQST
C
      INTEGER             LENQST,      STRING
      COMMON / NLS05  /   LENQST,      STRING(256)
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS06  /
C
C     UNUSED              TYPEND,      TYPHOL,      TYPINT,      TYPLOG
C     UNUSED              TYPNUL,      TYPSGL,      TYPVAR
C
      INTEGER             TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
      INTEGER             TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
      INTEGER             TYPVAR
      COMMON / NLS06  /   TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
      COMMON / NLS06  /   TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
      COMMON / NLS06  /   TYPVAR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS07  /
C
C     UNUSED              AMPSND,      BLANK,       COMMA,       DOLLAR
C     UNUSED              DQUOTE,      EQUALS,      HASHMK,      LPAREN
C     UNUSED              MINUS,       PERIOD,      PLUS,        RPAREN
C     UNUSED              SQUOTE,      STAR,        UCD,         UCE
C     UNUSED              UCF,         UCQ,         UCT,         USCORE
C
      INTEGER             AMPSND,      BLANK,       COMMA,       DOLLAR
      INTEGER             DQUOTE,      EQUALS,      HASHMK,      LPAREN
      INTEGER             MINUS,       PERIOD,      PLUS,        RPAREN
      INTEGER             SQUOTE,      STAR,        UCD,         UCE
      INTEGER             UCF,         UCQ,         UCT,         USCORE
      COMMON / NLS07  /   AMPSND,      BLANK,       COMMA,       DOLLAR
      COMMON / NLS07  /   DQUOTE,      EQUALS,      HASHMK,      LPAREN
      COMMON / NLS07  /   MINUS,       PERIOD,      PLUS,        RPAREN
      COMMON / NLS07  /   SQUOTE,      STAR,        UCD,         UCE
      COMMON / NLS07  /   UCF,         UCQ,         UCT,         USCORE
C
      DATA             SPACE /1H /
C
      DOUBLE = ((VARTYP .EQ. TYPDBL) .OR. (VARTYP .EQ. TYPCPX))
      NCHPWD = I1MACH(6)
      NCELLS = (LENQST + NCHPWD - 1)/NCHPWD
      OFFSET = MAX0(1,NREL) - 1
      LIMIT = MAX0(1,NRELMX)
      IF (DOUBLE) OFFSET = 2*OFFSET
      IF (DOUBLE) LIMIT = 2*LIMIT
           DO 10 I = 1,NREP
           LAST = MIN0(OFFSET+NCELLS,LIMIT)
           UNSPEC(LAST) = SPACE
           IF (DOUBLE .AND. (LAST .LT. LIMIT)) UNSPEC(LAST+1) = SPACE
           CALL KARMOV (UNSPEC(OFFSET+1),1,STRING,1,MIN0((LIMIT-OFFSET)*
     X          NCHPWD,LENQST))
           OFFSET = OFFSET + NCELLS
           IF (OFFSET .GE. LIMIT) GO TO 20
   10      CONTINUE
   20 NREL = LAST
      IF (DOUBLE) NREL = (NREL + 1)/2
      LENQST = 0
C
      RETURN
      END
      SUBROUTINE  NLSSI (N)
C     (NAMELIST - Store INTEGER)
C     Store in N(n) the current input value(s), updating NREL  in
C     COMMON to the next available position.
C     (16-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       INT,         MAX0,        SNGL
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             INT,         MAX0
      REAL                SNGL
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           N
C
      INTEGER             I,           N(1)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS01  /
C
C     UNUSED              NRELMX,      VARTYP,      VCPX,        VLOG
C
C     SETS                NREL
C
      DOUBLE PRECISION    VDBL
      COMPLEX             VCPX
      INTEGER             VARTYP,      NREL,        NRELMX,      NREP
      LOGICAL             VLOG
      COMMON / NLS01  /   VCPX,        VDBL,        VLOG,        VARTYP
      COMMON / NLS01  /   NREL,        NRELMX,      NREP
C
      NREL = MAX0(1,NREL)
           DO 10 I = 1,NREP
           N(NREL) = INT(SNGL(VDBL))
   10      NREL = NREL + 1
C
      RETURN
      END
      SUBROUTINE  NLSSL (L)
C     (NAMELIST - Store LOGICAL)
C     Store in L(n) the current input value(s), updating NREL  in
C     COMMON to the next available position.
C     (10-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       MAX0
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MAX0
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           L
C
      INTEGER             I
      LOGICAL             L(1)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS01  /
C
C     UNUSED              NRELMX,      VARTYP,      VCPX,        VDBL
C
C     SETS                NREL
C
      DOUBLE PRECISION    VDBL
      COMPLEX             VCPX
      INTEGER             VARTYP,      NREL,        NRELMX,      NREP
      LOGICAL             VLOG
      COMMON / NLS01  /   VCPX,        VDBL,        VLOG,        VARTYP
      COMMON / NLS01  /   NREL,        NRELMX,      NREP
C
      NREL = MAX0(1,NREL)
           DO 10 I = 1,NREP
           L(NREL) = VLOG
   10      NREL = NREL + 1
C
      RETURN
      END
      SUBROUTINE  NLSSR (R)
C     (NAMELIST - Store REAL)
C     Store in R(n) the current input value(s), updating NREL  in
C     COMMON to the next available position.
C     (16-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       MAX0,        SNGL
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MAX0
      REAL                SNGL
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           R
C
      INTEGER             I
      REAL                R(1)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS01  /
C
C     UNUSED              NRELMX,      VARTYP,      VCPX,        VLOG
C
C     SETS                NREL
C
      DOUBLE PRECISION    VDBL
      COMPLEX             VCPX
      INTEGER             VARTYP,      NREL,        NRELMX,      NREP
      LOGICAL             VLOG
      COMMON / NLS01  /   VCPX,        VDBL,        VLOG,        VARTYP
      COMMON / NLS01  /   NREL,        NRELMX,      NREP
C
      NREL = MAX0(1,NREL)
           DO 10 I = 1,NREP
           R(NREL) = SNGL(VDBL)
   10      NREL = NREL + 1
C
      RETURN
      END
      SUBROUTINE  NLSSTV (UNSPEC)
C     (NAMELIST - Store Value)
C     Return in  UNSPEC(n)  the current  input  value.   Routines
C     NLSSC, NLSSI, NLSSL, NLSSD, and NLSSR are actually used  to
C     install the value according to its data type.
C     (10-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       NLSSC,       NLSSD,       NLSSH,       NLSSI
C     EXTERNAL REFS       NLSSL,       NLSSR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             UNSPEC(1)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS01  /
C
C     UNUSED              NREL,        NRELMX,      NREP,        VCPX
C     UNUSED              VDBL,        VLOG
C
      DOUBLE PRECISION    VDBL
      COMPLEX             VCPX
      INTEGER             VARTYP,      NREL,        NRELMX,      NREP
      LOGICAL             VLOG
      COMMON / NLS01  /   VCPX,        VDBL,        VLOG,        VARTYP
      COMMON / NLS01  /   NREL,        NRELMX,      NREP
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS05  /
C
C     UNUSED              STRING
C
      INTEGER             LENQST,      STRING
      COMMON / NLS05  /   LENQST,      STRING(256)
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS06  /
C
C     UNUSED              TYPEND,      TYPHOL,      TYPNUL,      TYPVAR
C
      INTEGER             TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
      INTEGER             TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
      INTEGER             TYPVAR
      COMMON / NLS06  /   TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
      COMMON / NLS06  /   TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
      COMMON / NLS06  /   TYPVAR
C
      IF (LENQST .LE. 0) GO TO 10
      CALL NLSSH (UNSPEC)
      GO TO 20
   10 IF (VARTYP .EQ. TYPLOG) CALL NLSSL (UNSPEC)
      IF (VARTYP .EQ. TYPINT) CALL NLSSI (UNSPEC)
      IF (VARTYP .EQ. TYPSGL) CALL NLSSR (UNSPEC)
      IF (VARTYP .EQ. TYPDBL) CALL NLSSD (UNSPEC)
      IF (VARTYP .EQ. TYPCPX) CALL NLSSC (UNSPEC)
C
   20 RETURN
      END
      INTEGER FUNCTION  NLSTOK (MODE,VNAME)
C     (NAMELIST - Token)
C     Decode the next constant or name token in the input stream.
C     The value of  a constant is  left in COMMON,  while a  name
C     token is returned packed  in VNAME (1..8 characters,  blank
C     padded on the right).  If a name token is found,  constants
C     in COMMON are not set, and if a constant is found, VNAME is
C     not set.
C
C     Variable names must correspond to acceptable FORTRAN syntax
C     (1..6 characters,  first  from A..Z,  remainder  from  A..Z
C     0..9), although lower-case letters will also be accepted.
C
C     Values may optionally  be preceded by  a positive  unsigned
C     integer, zero or more blanks, an asterisk, and zero or more
C     blanks, forming a repeat count.   NREP in COMMON is set  to
C     the repeat count,  or 1  if none  was specified.   Trailing
C     blanks are skipped,  and the scan  stops past a  delimiting
C     comma, or at  the first character  immediately following  a
C     variable name.
C
C     Numbers are  accumulated in  DOUBLE PRECISION  and left  in
C     COMMON in  VDBL  for  INTEGER, DOUBLE  PRECISION  and  REAL
C     variables, and  in  VCPX  for a  COMPLEX  variable.   If  a
C     COMPLEX constant is input  for a non-complex variable,  the
C     real  part  is  also  stored  in  VDBL  on  return.   If  a
C     non-complex constant is input for a COMPLEX variable, it is
C     stored as the real part of VCPX with the imaginary part set
C     to zero.  Numeric values  0 and 1  for .TRUE.  and  .FALSE.
C     respectively  are  accepted.   Attempts  to  store  numeric
C     values other than 0 or 1 in LOGICAL variables, or  attempts
C     to  store  non-string  data  in  Hollerith  variables,  are
C     illegal.
C
C     MODE is set  to TYPVAR (new  variable found), TYPNUL  (null
C     data item), TYPEND ($END  found), TYPLOG (LOGICAL),  TYPINT
C     (INTEGER), TYPCPX (COMPLEX), TYPSGL (REAL), TYPDBL  (DOUBLE
C     PRECISION), or  TYPHOL  (Hollerith string).   The  function
C     value is set to OKAY  (success), SYNERR (syntax error),  or
C     EOFERR (end-of-file).
C     (18-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CMPLX,       INT,         KARMOV,      MAX0
C     EXTERNAL REFS       MIN0,        NLSCKD,      NLSDFC,      NLSEQU
C     EXTERNAL REFS       NLSGNB,      NLSNC,       NLSQST,      NLSWEM
C     EXTERNAL REFS       SNGL
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             NLSCKD,      NLSDFC,      NLSGNB,      NLSNC
      INTEGER             NLSQST
      LOGICAL             NLSEQU
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      COMPLEX             CMPLX
      INTEGER             INT,         MAX0,        MIN0
      REAL                SNGL
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             ISALFA,      ISCSEP,      ISDIG,       ISDOLL
      LOGICAL             ISNAME,      ISPUNC,      ISSIGN
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CODE,        ENDNAM,      EOS,         FALSE1
C     SETS                FALSE2,      LENTOK,      MAXTOK,      MODE
C     SETS                NEXT,        PLEVEL,      TOKEN,       TRUE1
C     SETS                TRUE2
C
      DOUBLE PRECISION    VIMAG,       VREAL
      INTEGER             ARG,         CODE,        DUMMY
      INTEGER             ENDNAM(4),   EOS,         FALSE1(4)
      INTEGER             FALSE2(8),   LENTOK,      MAXTOK,      MODE
      INTEGER             NEXT,        PLEVEL,      TOKEN(81)
      INTEGER             TRUE1(4),    TRUE2(7),    VNAME(1)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS01  /
C
C     UNUSED              NREL,        NRELMX
C
C     SETS                NREP,        VCPX,        VDBL,        VLOG
C
      DOUBLE PRECISION    VDBL
      COMPLEX             VCPX
      INTEGER             VARTYP,      NREL,        NRELMX,      NREP
      LOGICAL             VLOG
      COMMON / NLS01  /   VCPX,        VDBL,        VLOG,        VARTYP
      COMMON / NLS01  /   NREL,        NRELMX,      NREP
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS02  /
C
      INTEGER             UCORD
      COMMON / NLS02  /   UCORD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS03  /
C
      INTEGER             HOSTCH
      COMMON / NLS03  /   HOSTCH
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS04  /
C
      INTEGER             EOFERR,      OKAY,        SYNERR
      COMMON / NLS04  /   EOFERR,      OKAY,        SYNERR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS06  /
C
C     UNUSED              TYPDBL,      TYPSGL
C
      INTEGER             TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
      INTEGER             TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
      INTEGER             TYPVAR
      COMMON / NLS06  /   TYPCPX,      TYPDBL,      TYPEND,      TYPHOL
      COMMON / NLS06  /   TYPINT,      TYPLOG,      TYPNUL,      TYPSGL
      COMMON / NLS06  /   TYPVAR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS07  /
C
C     UNUSED              EQUALS,      UCD,         UCE,         UCQ
C
      INTEGER             AMPSND,      BLANK,       COMMA,       DOLLAR
      INTEGER             DQUOTE,      EQUALS,      HASHMK,      LPAREN
      INTEGER             MINUS,       PERIOD,      PLUS,        RPAREN
      INTEGER             SQUOTE,      STAR,        UCD,         UCE
      INTEGER             UCF,         UCQ,         UCT,         USCORE
      COMMON / NLS07  /   AMPSND,      BLANK,       COMMA,       DOLLAR
      COMMON / NLS07  /   DQUOTE,      EQUALS,      HASHMK,      LPAREN
      COMMON / NLS07  /   MINUS,       PERIOD,      PLUS,        RPAREN
      COMMON / NLS07  /   SQUOTE,      STAR,        UCD,         UCE
      COMMON / NLS07  /   UCF,         UCQ,         UCT,         USCORE
C
C     Constant string  declarations of  upper-case ASCII  ordinal
C     values for "END",  ".F.", ".FALSE.",  ".T.", and  ".TRUE.".
C     Each is terminated by EOS (End-Of-String), which may be any
C     value out of the ASCII range  0..127, but must be the  same
C     value in all DATA statements here and in other routines  in
C     this package.
C
      DATA             EOS   /-1/
      DATA             MAXTOK/80/
      DATA             ENDNAM(1),ENDNAM(2),ENDNAM(3),ENDNAM(4)
     X                 /69,78,68,-1/
      DATA             FALSE1(1),FALSE1(2),FALSE1(3),FALSE1(4)
     X                 /46,70,46,-1/
      DATA             FALSE2(1),FALSE2(2),FALSE2(3),FALSE2(4),
     X                 FALSE2(5),FALSE2(6),FALSE2(7),FALSE2(8)
     X                 /46,70,65,76,83,69,46,-1/
      DATA             TRUE1(1),TRUE1(2),TRUE1(3),TRUE1(4)
     X                 /46,84,46,-1/
      DATA             TRUE2(1),TRUE2(2),TRUE2(3),TRUE2(4),
     X                 TRUE2(5),TRUE2(6),TRUE2(7)
     X                 /46,84,82,85,69,46,-1/
C
      ISALFA(ARG) = (65 .LE. ARG) .AND. (ARG .LE. 90)
      ISCSEP(ARG) = (ARG .EQ. LPAREN) .OR. (ARG .EQ. COMMA) .OR.(ARG
     X     .EQ. RPAREN)
      ISDIG (ARG) = (48 .LE. ARG) .AND. (ARG .LE. 57)
      ISDOLL(ARG) = (ARG .EQ. DOLLAR) .OR. (ARG .EQ. AMPSND)
      ISNAME(ARG) = ISALFA(ARG) .OR. ISDIG(ARG)
      ISPUNC(ARG) = (ARG .EQ. PERIOD) .OR. (ARG .EQ. HASHMK) .OR.(ARG
     X     .EQ. USCORE)
      ISSIGN(ARG) = (ARG .EQ. PLUS) .OR. (ARG .EQ. MINUS)
C
      NREP = 0
      VDBL = 0.0D+00
   10 LENTOK = 0
C
C     Advance to the next non-blank  character.  On the basis  of
C     it, decide whether we have a quoted string, a comma (i.e. a
C     null item),  a  complex  constant,  or  some  other  token.
C     String decoding is left to NLSQST, and null items are easy.
C     Otherwise, we build a  token from the following  characters
C     up to the  next delimiting character  (anything but  digit,
C     letter, dot, plus, minus), or for a complex constant, up to
C     the closing right parenthesis.
C
      CODE = NLSGNB (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
      IF (.NOT.((UCORD .EQ. SQUOTE) .OR. (UCORD .EQ. DQUOTE))) GO TO 20
C
C     Parse a quoted string.
C
      CODE = NLSQST (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
      IF (CODE .EQ. SYNERR) GO TO 340
      MODE = TYPHOL
      GO TO 230
C
C     We do not  have a  quoted string.  Must  be comma,  dollar,
C     name, numeric constant, or logical constant.
C
   20 IF (UCORD .NE. COMMA) GO TO 30
C
C     We have a comma, implying  a null data item.  Advance  past
C     it and return.
C
      MODE = TYPNUL
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
      GO TO 230
C
C     Must  be  dollar,  name,   numeric  constant,  or   logical
C     constant.
C
   30 IF (.NOT.(ISDOLL(UCORD) .OR. ISALFA(UCORD))) GO TO 90
      CALL KARMOV (VNAME,1,7H       ,1,7)
      GO TO 50
C
C     We have  a dollar  or  name token,  so collect  it.   Token
C     buffer overflow results in a syntax error.
C
   40 IF (.NOT.ISNAME(UCORD)) GO TO 60
   50 LENTOK = MIN0(LENTOK + 1,MAXTOK)
      TOKEN(LENTOK) = UCORD
      IF (LENTOK .LE. 6) CALL KARMOV (VNAME,LENTOK,HOSTCH,1,1)
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
      GO TO 40
   60 TOKEN(LENTOK+1) = EOS
      IF (LENTOK .GE. MAXTOK) GO TO 250
      IF (.NOT.ISDOLL(TOKEN(1))) GO TO 80
C
C     Token begins with dollar.  Check  for $ and $END;  anything
C     else is illegal.
C
      IF (LENTOK .NE. 1) GO TO 70
C
C     Token was bare $; accept as equivalent to $END.
C
      MODE = TYPEND
      GO TO 230
   70 IF (.NOT.NLSEQU(TOKEN(2),ENDNAM)) GO TO 280
C
C     Token was $END.
C
      MODE = TYPEND
      GO TO 230
C
C     Must be name token.  Check for a valid token length, and if
C     okay, accept it and advance to the next non-blank character
C     in the input.
C
   80 MODE = TYPVAR
      IF (LENTOK .GT. 6) GO TO 240
      CODE = NLSGNB (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
C
C     At this  point,  we  can  do  a  1-character  single  token
C     lookahead  to  allow  T  and  F  to  represent  a   LOGICAL
C     constants; if the current input  character is a comma or  a
C     dollar, and the current token is  either T or F, we have  a
C     LOGICAL constant.  Otherwise, we must have a name token (or
C     possibly a syntax error to be caught later).
C
      IF (LENTOK .GT. 1) GO TO 230
      IF (.NOT.(ISDOLL(UCORD) .OR. (UCORD .EQ. COMMA))) GO TO 230
      IF (.NOT.((TOKEN(1) .EQ. UCF) .OR. (TOKEN(1) .EQ. UCT))) GO TO 230
      VLOG = (TOKEN(1) .EQ. UCT)
      MODE = TYPLOG
      GO TO 220
C
C     Token must be numeric constant or logical constant.
C
   90 IF (UCORD .NE. LPAREN) GO TO 140
C
C     Must be complex constant (real,imag); collect the token  up
C     to the matching closing right parenthesis, and advance  the
C     input character to  whatever follows  the parenthesis.   In
C     order to avoid  token buffer  overflow, blanks  surrounding
C     the complex constant separators "(,)" are skipped on input,
C     and trimmed  from  the  token  buffer  if  they  have  been
C     accumulated.
C
      PLEVEL = 1
      LENTOK = 1
      TOKEN(LENTOK) = UCORD
  100 CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
      IF (.NOT.ISCSEP(TOKEN(LENTOK))) GO TO 110
      CODE = NLSGNB (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
  110 IF (UCORD .EQ. LPAREN) PLEVEL = PLEVEL + 1
      IF (UCORD .EQ. RPAREN) PLEVEL = PLEVEL - 1
      IF (.NOT.ISCSEP(UCORD)) GO TO 130
  120 IF (TOKEN(LENTOK) .NE. BLANK) GO TO 130
      LENTOK = LENTOK - 1
      GO TO 120
  130 LENTOK = MIN0(LENTOK + 1,MAXTOK)
      TOKEN(LENTOK) = UCORD
      IF (PLEVEL .NE. 0) GO TO 100
      TOKEN(LENTOK+1) = EOS
      IF (LENTOK .GE. MAXTOK) GO TO 250
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
      GO TO 160
C
C     We must have a REAL, DOUBLE PRECISION, INTEGER, or  LOGICAL
C     constant.  Collect  the  token  up to  the  next  delimiter
C     (anything but digit, letter, dot, plus, minus,  underscore,
C     or hash mark).
C
  140 IF (.NOT.(ISALFA(UCORD) .OR. ISDIG(UCORD) .OR. ISSIGN(UCORD).OR.
     X     ISPUNC(UCORD))) GO TO 150
      LENTOK = MIN0(LENTOK + 1,MAXTOK)
      TOKEN(LENTOK) = UCORD
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
      GO TO 140
  150 TOKEN(LENTOK+1) = EOS
      IF (LENTOK .GE. MAXTOK) GO TO 250
C
C     At this  point, TOKEN(*)  contains a  token which  must  be
C     decoded.  Since it  is complete, we  can readily  determine
C     whether it  is a  logical constant  (.TRUE., .FALSE.,  .T.,
C     .F.),  a  complex  constant  ((real,imag)),  or  a  numeric
C     constant.
C
  160 IF (LENTOK .LE. 0) GO TO 260
      IF (TOKEN(1) .NE. LPAREN) GO TO 170
C
C     We have a complex constant.  Decode the real and  imaginary
C     parts separately,  and  save  the real  part  in  case  the
C     variable is not complex.
C
      NEXT = 2
      CODE = NLSDFC (VREAL,MODE,TOKEN,NEXT)
      IF (CODE .EQ. SYNERR) GO TO 260
      IF (TOKEN(NEXT) .NE. COMMA) GO TO 270
      VDBL = VREAL
      NEXT = NEXT + 1
      CODE = NLSDFC (VIMAG,MODE,TOKEN,NEXT)
      IF (CODE .EQ. SYNERR) GO TO 260
      IF (TOKEN(NEXT) .NE. RPAREN) GO TO 290
      VCPX = CMPLX(SNGL(VREAL),SNGL(VIMAG))
      MODE = TYPCPX
      GO TO 220
C
C     Must be a LOGICAL  constant or a  numeric constant of  type
C     REAL, DOUBLE PRECISION, or INTEGER.
C
  170 IF (TOKEN(1) .NE. PERIOD) GO TO 210
C
C     Check for acceptable LOGICAL constants (.F., .FALSE.,  .T.,
C     .TRUE.).
C
      IF (.NOT.NLSEQU(TOKEN,FALSE1)) GO TO 180
      VLOG = .FALSE.
      MODE = TYPLOG
      GO TO 220
  180 IF (.NOT.NLSEQU(TOKEN,FALSE2)) GO TO 190
      VLOG = .FALSE.
      MODE = TYPLOG
      GO TO 220
  190 IF (.NOT.NLSEQU(TOKEN,TRUE1)) GO TO 200
      VLOG = .TRUE.
      MODE = TYPLOG
      GO TO 220
  200 IF (.NOT.NLSEQU(TOKEN,TRUE2)) GO TO 210
      VLOG = .TRUE.
      MODE = TYPLOG
      GO TO 220
C
C     The token must be a single numeric constant.
C
  210 NEXT = 1
      CODE = NLSDFC (VDBL,MODE,TOKEN,NEXT)
      IF (CODE .EQ. SYNERR) GO TO 260
C
C     At this point, we have successfully parsed a constant.   We
C     must now  scan ahead  to the  delimiting character  in  the
C     input to see if possibly this was a repeat count field (n *
C     value).  If  it was,  and if  the preceding  constant as  a
C     positive unsigned integer,  we save the  repeat count,  and
C     restart the  scan for  the next  token.  This  is the  only
C     place where we have to jump back in the code.
C
      CODE = NLSGNB (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
      IF (UCORD .NE. STAR) GO TO 220
      IF ((VDBL .LE. 0.0D+00) .OR. ISSIGN(TOKEN(1)) .OR. (NREP .GT. 0)
     X     .OR. (MODE .NE. TYPINT)) GO TO 310
      NREP = INT(SNGL(VDBL))
      CODE = NLSNC (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
      GO TO 10
C
C     We have successfully  parsed a constant.   Verify that  the
C     correct delimiter follows it, and if so, accept the  value.
C
  220 CODE = NLSCKD (DUMMY)
      IF (CODE .EQ. EOFERR) GO TO 350
      IF (CODE .EQ. SYNERR) GO TO 300
C
C     Successful parse.   Now  check  the type  of  the  constant
C     against the variable data  type.  A Hollerith variable  may
C     only receive Hollerith data.   A LOGICAL variable may  only
C     receive numeric values if they are 0 or 1.
C
      IF (MODE .EQ. TYPHOL) GO TO 230
      IF ((VARTYP .EQ. TYPHOL) .AND. (MODE .NE. TYPHOL)) GO TO 320
      IF ((VARTYP .EQ. TYPLOG) .AND. (MODE .NE. TYPLOG) .AND.(VDBL .NE.
     X     0.0D+00) .AND. (VDBL .NE. 1.0D+00)) GO TO 330
C
C     Finally,  do  any   necessary  constant  type   conversions
C     according to the variable type.
C
      IF ((VARTYP .EQ. TYPLOG) .AND. (MODE .NE. TYPLOG)) VLOG =(VDBL
     X     .EQ. 1.0D+00)
      IF ((VARTYP .EQ. TYPCPX) .AND. (MODE .NE. TYPCPX)) VCPX =CMPLX
     X     (SNGL(VDBL),0.0E+00)
C
C     Termination and error message section.
C
  230 NLSTOK = OKAY
      NREP = MAX0(1,NREP)
      GO TO 360
C
  240 CALL NLSWEM (41HInput name token longer than 6 characters,41)
      GO TO 340
  250 CALL NLSWEM (
     X     53HInput token too long for internal 80-character buffer,53)
      GO TO 340
  260 CALL NLSWEM (33HIllegal NAMELIST input data field,33)
      GO TO 340
  270 CALL NLSWEM (
     X     50HExpected comma after real part of complex constant,50)
      GO TO 340
  280 CALL NLSWEM (28HIllegal variable name syntax,28)
      GO TO 340
  290 CALL NLSWEM (
     X75HExpected closing right parenthesis after imaginary part of comp
     Xlex constant,75)
      GO TO 340
  300 CALL NLSWEM (47HExpected comma or $END delimiter after constant,
     X     47)
      GO TO 340
  310 CALL NLSWEM (46HRepeat count must be positive unsigned integer,46)
      GO TO 340
  320 CALL NLSWEM (
     X     54HIllegal to input non-string data to Hollerith variable,54)
      GO TO 340
  330 CALL NLSWEM (
     X     57HIllegal to input non-LOGICAL constant to LOGICAL variable,
     X     57)
      GO TO 340
  340 NLSTOK = SYNERR
      GO TO 360
C
  350 NLSTOK = EOFERR
      GO TO 360
C
  360 RETURN
      END
      SUBROUTINE  NLSWBC
C     (NAMELIST - Write Bad Card)
C     On error, print the bad card image, showing where the  scan
C     terminated.
C     (10-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C                      HOLLERITH STRING VARIABLES
C
      INTEGER             DASH,        MARKER
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                J
C
      INTEGER             J
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS07  /
C
C     UNUSED              AMPSND,      BLANK,       COMMA,       DOLLAR
C     UNUSED              DQUOTE,      EQUALS,      HASHMK,      LPAREN
C     UNUSED              MINUS,       PERIOD,      PLUS,        RPAREN
C     UNUSED              SQUOTE,      STAR,        UCD,         UCE
C     UNUSED              UCF,         UCQ,         UCT,         USCORE
C
      INTEGER             AMPSND,      BLANK,       COMMA,       DOLLAR
      INTEGER             DQUOTE,      EQUALS,      HASHMK,      LPAREN
      INTEGER             MINUS,       PERIOD,      PLUS,        RPAREN
      INTEGER             SQUOTE,      STAR,        UCD,         UCE
      INTEGER             UCF,         UCQ,         UCT,         USCORE
      COMMON / NLS07  /   AMPSND,      BLANK,       COMMA,       DOLLAR
      COMMON / NLS07  /   DQUOTE,      EQUALS,      HASHMK,      LPAREN
      COMMON / NLS07  /   MINUS,       PERIOD,      PLUS,        RPAREN
      COMMON / NLS07  /   SQUOTE,      STAR,        UCD,         UCE
      COMMON / NLS07  /   UCF,         UCQ,         UCT,         USCORE
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS08  /
C
      INTEGER             LINENO,      CPOS,        C
      COMMON / NLS08  /   LINENO,      CPOS,        C(80)
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS09  /
C
C     UNUSED              INUNIT
C
      INTEGER             ERUNIT,      INUNIT
      COMMON / NLS09  /   ERUNIT,      INUNIT
C
      DATA             DASH/1H-/, MARKER/1H#/
C
      IF (ERUNIT .NE. 0) WRITE (ERUNIT,1000) LINENO,MARKER,C
      IF (ERUNIT .NE. 0) WRITE (ERUNIT,2000) (DASH,J = 1,CPOS),MARKER
C
      RETURN
C
 1000 FORMAT (36H Error detected at input line number,I6,1H./
     X        1X,A1,39H appears under last character processed/2X,80A1)
 2000 FORMAT (1X,81A1)
      END
      SUBROUTINE  NLSWEM (TEXT,LENTXT)
C     (NAMELIST - Write Error Message)
C     Write a packed error message to the error file.
C     (13-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       NLSWEV
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                NULL
C
      INTEGER             LENTXT,      NULL(1),     TEXT(1)
C
      DATA             NULL(1) /0/
C
      CALL NLSWEV (TEXT,LENTXT,NULL)
C
      RETURN
      END
      SUBROUTINE  NLSWEV (TEXT,LENTXT,NAME)
C     (NAMELIST - Write Error Message and Value)
C     Write a packed error message to the error file.  If NAME(1)
C     is non-zero, it is assumed to contain an 8-character packed
C     string which will be written following the message.
C     (13-FEB-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       KARASC,      KARUPK,      MAX0,        MIN0
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             KARASC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MAX0,        MIN0
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C                      HOLLERITH STRING VARIABLES
C
      INTEGER             BLANK,       QUOTE
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           LEN,         LINE,        MAXLIN
C
      INTEGER             CHAR,        I,           LEN,         LENTXT
      INTEGER             LINE(92),    MAXLIN,      NAME(1),     TEXT(1)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / NLS09  /
C
C     UNUSED              INUNIT
C
      INTEGER             ERUNIT,      INUNIT
      COMMON / NLS09  /   ERUNIT,      INUNIT
C
      DATA             BLANK /1H /
      DATA             MAXLIN/92/
      DATA             QUOTE /1H"/
C
      IF (ERUNIT .EQ. 0) GO TO 40
      LEN = MIN0(MAXLIN-9,MAX0(1,LENTXT))
      CALL KARUPK (LINE,TEXT,1,LEN)
      IF (NAME(1) .EQ. 0) GO TO 30
      LINE(LEN+1) = BLANK
      LINE(LEN+2) = QUOTE
      LEN = LEN + 2
      I = 1
   10 CALL KARMOV (CHAR,1,NAME,I,1)
      IF (KARASC(CHAR) .EQ. KARASC(BLANK)) GO TO 20
      LEN = LEN + 1
      LINE(LEN) = CHAR
      I = I + 1
      IF (I .LE. 8) GO TO 10
   20 LEN = LEN + 1
      LINE(LEN) = QUOTE
   30 WRITE (ERUNIT,1000) (LINE(I), I = 1,LEN)
C
   40 RETURN
C
 1000 FORMAT (/11H ?NLSERR - ,92A1)
      END
