      SUBROUTINE  P79GCL (CMDLIN,MAXLIN,LENGTH)
C     (Get Command Line)
C     Return the command line  (excluding the  program name) with
C     the contents of an option file appended  to provide default
C     options.  P79CMD is used to  retrieve the command line; the
C     option file processing is supplied here.
C
C     The option files tried are, in order:
C
C     .xxxrc
C     $HOME/.xxxrc
C     xxx.opt
C     $HOME/xxx.opt
C
C     where xxx is  the program name.   Only the first file found
C     is used.
C     (25-Sep-1993)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHRTRM,      MIN0
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      CHARACTER*255       CMD,         FILNAM,      HOME,        LINE
      CHARACTER*255       ROOT
      INTEGER             CMDLIN(*),   H,           IOS,         K
      INTEGER             L,           LENGTH,      MAXLIN,      OPTFIL
      INTEGER             R
      LOGICAL             EOFILE,      ISFILE
C
C     Get the entire command line
C
      CALL P79CMD (CMD,LENGTH)
      CALL CHRCTH (CMDLIN,1,LENGTH,CMD)
C
C     Get the program name "/foo/bar/programname" and strip off the
C     leading pathname.
C
      CALL P79ARG(0,LINE)
      L = CHRTRM(LINE)
      K = L
20001 IF (.NOT.(LINE(K:K) .NE.  '/')) GO TO 20002
      K = K - 1
      IF (K .LE. 0) GO TO 20002
      GO TO 20001
20002 IF (.NOT.(K .LT. L)) GO TO 20003
      ROOT = LINE(K+1:L)
      R = L - K
      GO TO 20004
20003 ROOT = LINE(1:L)
      R = L
20004 IF (.NOT.(R .GT. 4)) GO TO 20006
      IF ( (ROOT(R-3:R) .EQ. '.EXE') .OR.
     X(ROOT(R-3:R) .EQ. '.exe') ) R = R - 4
C
C     Get the login directory name from $HOME.
C
20006 CALL P79ENV('HOME',HOME)
      H = CHRTRM(HOME)
      IF (.NOT.(HOME(H:H) .NE. '/')) GO TO 20009
      H = H + 1
      HOME(H:H) = '/'
C
C     Form UNIX-style .XXXrc option file name.
C
20009 FILNAM = '.' // ROOT(1:R) // 'rc'
      INQUIRE (FILE=FILNAM,EXIST=ISFILE)
      IF (.NOT.(.NOT.ISFILE)) GO TO 20012
      LINE = HOME(1:H) // FILNAM
      FILNAM = LINE
      INQUIRE (FILE=FILNAM,EXIST=ISFILE)
20012 IF (.NOT.(.NOT.ISFILE)) GO TO 20015
      FILNAM = ROOT(1:R) // '.opt'
      INQUIRE (FILE=FILNAM,EXIST=ISFILE)
20015 IF (.NOT.(.NOT.ISFILE)) GO TO 20018
      LINE = HOME(1:H) // FILNAM
      FILNAM = LINE
      INQUIRE (FILE=FILNAM,EXIST=ISFILE)
C
C     If any of these files exists, open  and read the first line
C     and append it to the command line.
C
20018 IF (.NOT.(ISFILE)) GO TO 20021
C
C          Find  an available  unit number.    Many  UNIX systems
C          allow units 1..19.
C
      OPTFIL = 19
      GO TO 20025
20024 IF (.NOT.(ISFILE .AND. (OPTFIL .GT. 0))) GO TO 20026
20025 INQUIRE (UNIT=OPTFIL,OPENED=ISFILE)
      IF (ISFILE) OPTFIL = OPTFIL - 1
      GO TO 20024
20026 OPEN (UNIT=OPTFIL,FILE=FILNAM,ACCESS='sequential',
     XSTATUS='old',
     XFORM='formatted',
     XIOSTAT=IOS)
      IF (.NOT.(IOS .EQ. 0)) GO TO 20027
      REWIND OPTFIL
      LINE = ' '
      READ (OPTFIL,'(A)',END=20030) LINE
      EOFILE=.FALSE.
      GO TO 20031
20030 EOFILE=.TRUE.
20031 CLOSE (UNIT=OPTFIL)
      L = CHRTRM(LINE)
      L = MIN0(L,MAXLIN-LENGTH-1)
      CALL KARMOV(CMDLIN,LENGTH+1,1H ,1,1)
      CALL CHRCTH(CMDLIN,LENGTH+2,L,LINE)
      LENGTH = LENGTH + 1 + L
20027 CONTINUE
C
20021 RETURN
      END
