      INTEGER FUNCTION  P79OPT (LETTER)
C     (Command Option - UNIX version)
C     Search the run-time  command line  for an option letter and
C     possible  numeric  value returning P79OPT  .ge. 0 if found,
C     and -1 if not found.
C
C     The command line is retrieved by routine P79GCL as a packed
C     string.  P79GCL gets the run-time command line, and then it
C     appends to this the  first 80  characters  of a file  named
C     "prgnam.opt", if one exists, where  "prgnam" is the name of
C     the  program being  run.   This  permits users  to maintain
C     their own default options.
C
C     Options may take the form
C
C     -l
C
C     or
C
C     -l:nnn
C
C     where "l" is a letter and  "nnn" is a  string  of 1 or more
C     decimal digits.   If the requested  option  is found, and a
C     numeric value is  specified,  then P79OPT =  nnn on return.
C     If  no numeric  value  is  specified,  then  P79OPT = 0  on
C     return.  Thus -l and -l:0 are equivalent.  The command line
C     takes the form
C
C     sf3 -a -b -c -d ...
C
C     where -a -b  -c -d  ... are options.  The text  returned in
C     the command line has the  program name removed, so  that it
C     appears as "-a -b -c -d ...".
C     (02-Mar-1991)
      INTEGER          CMDLIN(30),  COLNRZ,      DASHRZ,      DECVAL
      INTEGER          IARG,        K,           KARASC,      KARUC
      INTEGER          LASTCH,      LENCMD
      INTEGER          LETTCH,      LETTER(1),   MAXCMD,      NEXTCH
      INTEGER          NINERZ,      RESULT,      SLSHRZ,      ZERORZ
      LOGICAL          DECDIG,      DIGIT,       FIRST,       FOUND
      LOGICAL          MORE
C
      SAVE             CMDLIN,      FIRST,       LENCMD
C
      DATA             FIRST    /.TRUE./
      DATA             MAXCMD   / 30 /
C
C     LOGICAL statement function returning .TRUE. if right-zero
C     character argument is a decimal digit.
C
      DECDIG(IARG) = (ZERORZ .LE. IARG) .AND. (IARG .LE. NINERZ)
C
C     INTEGER statement function returning integer value of a
C     character which is known to represent a digit.
C
      DECVAL(IARG) = IARG - ZERORZ
C
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 IF (.NOT.(LENCMD .GT. 0)) GO TO 20002
      ASSIGN 20005 TO NPR002
      GO TO 30002
20005 GO TO 20003
20002 RESULT = -1
20003 CONTINUE
20004 P79OPT = RESULT
C
      RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Initialize)
30001 IF (FIRST) CALL P79GCL (CMDLIN,MAXCMD,LENCMD)
      FIRST = .FALSE.
      ZERORZ = KARASC(1H0)
      NINERZ = KARASC(1H9)
      COLNRZ = KARASC(1H:)
      SLSHRZ = KARASC(1H/)
      DASHRZ = KARASC(1H-)
      GO TO 20001
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Search for the Option Letter)
30002 LETTCH = KARASC(KARUC(LETTER))
      K = 0
      LASTCH = 0
      GO TO 20007
20006 IF (FOUND .OR. .NOT.MORE) GO TO 20008
20007 ASSIGN 20009 TO NPR003
      GO TO 30003
20009 FOUND = (NEXTCH .EQ. LETTCH) .AND. (LASTCH .EQ. DASHRZ)
      LASTCH = NEXTCH
      GO TO 20006
20008 IF (.NOT.(FOUND)) GO TO 20010
      ASSIGN 20013 TO NPR004
      GO TO 30004
20013 GO TO 20011
20010 RESULT = -1
20011 GO TO 20005
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Extract Numeric Value, If Any)
30004 ASSIGN 20014 TO NPR003
      GO TO 30003
20014 IF (.NOT.(NEXTCH .EQ. COLNRZ)) GO TO 20015
      RESULT = 0
      GO TO 20019
20018 IF (.NOT.DIGIT) GO TO 20020
20019 ASSIGN 20021 TO NPR003
      GO TO 30003
20021 DIGIT = MORE .AND. DECDIG(NEXTCH)
      IF (DIGIT) RESULT = 10*RESULT + DECVAL(NEXTCH)
      GO TO 20018
20020 GO TO 20016
20015 RESULT = 0
20016 GO TO 20013
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Retrieve Next Character and Make Upper-Case)
30003 K = K + 1
      CALL KARGET (NEXTCH,CMDLIN,K)
      NEXTCH = KARASC(KARUC(NEXTCH))
      MORE = (K .LE. LENCMD)
      GO TO NPR003, (20009,20014,20021)
C
      END
