#include "p79.h"
#include <ctype.h>
#include <pwd.h>			/* for passwd  */

#define	MAXPNAME	128	/* length of internal personal name buffer */
#define TOUPPER(c) (islower(c) ? toupper(c) : (c))

#if __host_mips && defined(SYSTYPE_BSD43)
/* MIPS RC6280 EP/IX and RISCos are missing cuserid(), so we make it
evaluate to NULL so that getpwnam() will be used instead. */
#define cuserid(s) ((char*)NULL)
#else
char		*cuserid ARGS((char *s__));
#endif

#if _IBMR2 || (mips && MIPSEB)
struct passwd	*getpwnam ARGS((const char * name__)); /* missing in pwd.h */
#endif /* _IBMR2 || (mips && MIPSEB) */

/* Return the user personal name (on UNIX, from the /etc/passwd file */

void
FORTRAN(p79usr,P79USR)(personal_name, FLENARG(personal_name))
FCHAR		personal_name;
int		FLENARG(personal_name);
{
    int			n;
    char		*p;
    struct passwd	*passwdp;
    char		temp_name[MAXPNAME];
    char	*q;
    char		*user_name;

    passwdp = (struct passwd*)getpwuid(getuid());
    if (passwdp == (struct passwd *)NULL)
    {
	user_name = cuserid((char*)NULL);
	user_name = (user_name == (char*)NULL) ? "" : user_name;
	passwdp = getpwnam(user_name);
    }
    if (passwdp != (struct passwd *)NULL)
    {
	if (passwdp->pw_gecos[0] == '&')
	    p = passwdp->pw_name;	/* & means use login name */
	else
	    p = passwdp->pw_gecos;	/* have personal name */

	/***************************************************************
	  UNIX /etc/passwd file pw_gecos fields look like this:

	   "Jill Q. Doe"
	   "Jill Q. &"  (& ==> substitute user name)
	   "Jill Q. Doe, office, office phone, home phone"

	  We handle the & substitution, and stop at first comma or NUL,
	  even though this fails to correctly handle an entry like
	  "John Smith, Jr.".

	  Regrettably, there is little consistency or syntax
	  requirements on this field across variants of UNIX.
	***************************************************************/

	for (p = &temp_name[0], q = &passwdp->pw_gecos[0], n = 0;
	     *q && (*q != ',') && (n < MAXPNAME); q++)
	{
	    if (*q == '&')		/* substitute capitalized login name */
	    {
		*p++ = TOUPPER(*user_name);
		user_name++;
		n++;
		while ((n < MAXPNAME) && *user_name)
		{
		    *p++ = *user_name++;
		    n++;
		}
		continue;
	    }
	    else			/* just copy character */
	    {
		*p++ = *q;
		n++;
	    }
	}
	(void)memcpy(&CH(personal_name,0),temp_name,n);
	(void)memset(&CH(personal_name,n),' ',FLEN(personal_name) - n);
    }
    else
	(void)memset(&CH(personal_name,0),' ',FLEN(personal_name));
}
